 UNIT CrtPlus;
 {
   UNITE DE GESTION DES ROUTINES D'ECRAN EN MODE TEXTE
   Sad LANKRI,
   1997 - 2000.

   Dernire MAJ : le 28/12/00
 }

 INTERFACE

 USES Crt, Dos;

 TYPE DWORD      = LongInt;
      OnOff      = (On, Off);
      Chars      = SET OF Char;
      FieldType  = (Simple, Continue);
      BorderType = (Single, Double, Solid, HDouble, VDouble, NoBorder, UserDefinedBorder);

      Intensity  = (High, Low);

      ScrTab     = ARRAY [0..16383] OF BYTE;
      CharTab    = ARRAY [1..16] OF STRING[8];
      UserBorderTab = ARRAY [0..7] OF Char;

      TPoint     = RECORD
                 X, Y : WORD;
      END;

      TRect   = RECORD
              X1,Y1,X2,Y2 : WORD;
      END;

      ColorsRec  = RECORD
                 WindowTitle, TextZone, SelectedText, CloseButton, Disabled, HlpContext,
                 ShortCut, SelectedItem, UnselectedItem, TxtZoneName, ScreenColor : ARRAY[1..2] OF WORD;
                 ScreenChar : Char;
      END;

      RVBRec = RECORD
               R,V,B : BYTE;
      END;

      TPaletteArray = ARRAY[0..15] OF RVBRec;

      TVGAVideoBuf = RECORD {Buffer contenant les informations relatives
                            au mode texte actuel}
                   StaticData : DWORD;
                   VideoModeNum : BYTE;
                   NbColonnes   : WORD;
                   PageLength   : WORD;
                   PageStartAdr : WORD;
                   Reserved1    : ARRAY[1..16] OF BYTE;
                   CursorEndLine : BYTE;
                   CursorStartLine : BYTE;
                   CurPage         : BYTE;
                   CRTPortAdr      : WORD;
                   CRTCPort        : BYTE;
                   DACPort         : BYTE;
                   NbLignes        : BYTE;
                   CharHeight      : WORD;
                   AdaptatorNum    : BYTE;
                   InactiveAdaptatorNum : BYTE;
                   NbColours       : WORD;
                   NbPages         : BYTE;
      END;
      PVGAVideoBuf = ^TVGAVideoBuf;

 CONST FileNameChars = ['A'..'Z', 'a'..'z', '0'..'9',':','\','.','~','_'];
       Numbers       = ['0'..'9','.'];
       Letters       = ['A'..'Z', 'a'..'z',' ','','','','','',#80..#154,#160..#165];
       GenericChars  = ['!','?','''',';',',','&','#','(',')','"','/','[',']','+','-','*'];
       Hexadecimal   = ['0'..'9','A'..'F','a'..'f'];
       AlphaNumChars = Numbers + Letters;
       All           = AlphaNumChars + GenericChars;
       Next          = 2;
       Precedent     = 3;
       Cancel        = 1;
       Ok            = 0;
       YES           = TRUE;
       NO            = FALSE;
       SCRL =  16;                                     { Bit Scroll-Lock}
       NUML =  32;                                        { Bit Num-Lock}
       CAPL =  64;                                       { Bit Caps-Lock}

 VAR OldCursSize, TScreenSize, TxtColor : TPoint;
     UserBorder : UserBorderTab;
     Intense    : Intensity;
     CrtPlusVGAVideoBuf : PVGAVideoBuf;

 PROCEDURE Clear;
 PROCEDURE Delay(Temps : LongInt);
 PROCEDURE Bip;
 PROCEDURE TColor     (TxtColor, TxtGround : BYTE);
 PROCEDURE TSetColor  (ColorNum : BYTE; Red, Green, Blue : BYTE);
 PROCEDURE TGetColor  (ColorNum : BYTE; VAR Red, Green, Blue : BYTE);
 PROCEDURE SetCursorPos(X1, Y1 : BYTE);
 PROCEDURE TCenter   (Chaine : STRING; Ligne : BYTE);
 PROCEDURE TCenterXY (Chaine : STRING; Ligne, Col1,Col2 : BYTE);
 PROCEDURE TLeftText (Text : STRING; X1,Y1,X2,Y2 : BYTE);
 PROCEDURE TCenterText(Text : STRING; X1,Y1,X2,Y2 : BYTE);
 PROCEDURE TDrawBox  (X1,Y1, X2,Y2, TxtColor,TxtGround : BYTE; Ombre : OnOff; St : BorderType);
 PROCEDURE TBp       (X1,Y1,X2,Y2, Ct,Cb : BYTE; Ombre : OnOff; St : BorderType);
 PROCEDURE InvBP     (X1,Y1,X2,Y2, Ct,Cb : BYTE; Ombre : OnOff; St : BorderType);
 PROCEDURE TMkSpace  (Y1,Y2, Ligne : BYTE);
 PROCEDURE TWrite    (Chaine : STRING; Ligne, Colonne: BYTE);
 PROCEDURE TWFromTo  (Ch : Char; Col1,Col2, Ligne : BYTE);
 PROCEDURE TruncStr  (Longueur : BYTE; VAR Chaine : STRING);
 PROCEDURE DelChar   (Position : BYTE; VAR Chaine : STRING);
 PROCEDURE InsChar   (Position : BYTE; Ch : Char; VAR Chaine : STRING);
 PROCEDURE HorizSeparateur(X1,X2, Ligne: BYTE);
 PROCEDURE VertSeparateur (X1,X2, Colonne: BYTE);
 PROCEDURE DrawHScrollBar (Y1,Y2, X : BYTE; BlocPos : BYTE);
 PROCEDURE DrawVScrollBar (X1,X2, Y : BYTE; BlocPos : BYTE);
 PROCEDURE GetScr    (X1,Y1,X2,Y2 : BYTE; VAR Tab : ScrTab);
 PROCEDURE SetScr    (X1,Y1,X2,Y2 : BYTE; Tab : ScrTab);
 PROCEDURE VUpScroll (X1,Y1,X2,Y2 : BYTE);
 PROCEDURE VDownScroll (X1,Y1,X2,Y2 : BYTE);
 PROCEDURE BH;
 PROCEDURE Quit;
 PROCEDURE RedefChar   (Caractere,Hauteur : BYTE; Tab : CharTab);
 PROCEDURE GetCharForm (Caractere : BYTE; VAR CharTab : CharTab);
 PROCEDURE SetIntensity (Int : Intensity);
 PROCEDURE SetBorderColor (Couleur : BYTE);
 PROCEDURE Play(Freq : WORD; Temps : WORD);
 PROCEDURE HideCursor;
 PROCEDURE HideMouse;
 PROCEDURE ShowCursor;
 PROCEDURE ShowMouse;
 PROCEDURE SetMouseArea(X1,Y1,X2,Y2 : WORD);
 PROCEDURE SetMouseSensibility(HSensibility, VSensibility : WORD);
 PROCEDURE GetMousePosEvent(VAR X, Y : WORD; VAR G,M,D : BOOLEAN);
 PROCEDURE SetMousePos(X, Y : WORD);
 PROCEDURE SetCursorSize (X1, Y1 : BYTE);
 PROCEDURE SaveCursorSize;
 PROCEDURE SetTextMode (ModeNum : BYTE);
 PROCEDURE GetCurTextModeInfo (Buf : POINTER);
 PROCEDURE SetFlag(Flag : BYTE);
 PROCEDURE ClrFlag(Flag : BYTE);
 PROCEDURE SetRepeatFrequency(R,F : BYTE);
 PROCEDURE SetCharWidth(Largeur : BYTE);
 PROCEDURE TLoadPalette(Palette : TPaletteArray);
 PROCEDURE ClearKbdBuf;

 PROCEDURE CLI; INLINE($FA);
 PROCEDURE STI; INLINE($FB);


 FUNCTION InitMouse  : BOOLEAN;
 FUNCTION WaitForKey : BOOLEAN;
 FUNCTION DetectDir   (Path : STRING) : STRING;
 FUNCTION UpCaseStr   (Chaine : STRING) : STRING;
 FUNCTION LowCaseStr  (Chaine : STRING) : STRING;
 FUNCTION ExistFile   (FileName : STRING) : BOOLEAN;
 FUNCTION GetChar     (X,Y : BYTE) : BYTE;
 FUNCTION GetCharAttr (X,Y : BYTE) : BYTE;
 FUNCTION GetCharTextColor  (TColor : BYTE) : BYTE;
 FUNCTION GetCharBackGround (TColor : BYTE) : BYTE;
 FUNCTION GetVideoMode : BYTE;

 IMPLEMENTATION

 USES Keyboard, Convert;

 CONST Brill = 8;

 FUNCTION GetChar;
 BEGIN
      GetChar:= Mem[SegB800:(TScreenSize.X*(X-1) + (Y-1)) * 2];
 END;

 FUNCTION GetCharAttr;
 BEGIN
      GetCharAttr:= Mem[SegB800:(TScreenSize.X*(X-1) + (Y-1)) * 2 + 1];
 END;

 FUNCTION GetCharTextColor;
 BEGIN
      GetCharTextColor:= TColor AND (1+2+4+8);
 END;

 FUNCTION GetCharBackGround;
 BEGIN
      GetCharBackGround:= (TColor - GetCharTextColor(TColor)) DIV 16;
 END;

 FUNCTION GetVideoMode;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $0F;
      Intr($10, Regs);
      GetVideoMode:= Regs.AL;
 END;

 PROCEDURE GetCurTextModeInfo(Buf : POINTER);
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $1B; Regs.BX:= $00;
      Regs.ES:= DWORD(Buf) SHR 16; Regs.DI:= WORD(Buf);
      Intr($10, Regs);
 END;

 PROCEDURE GetScr;
 VAR I,J,K : WORD;
 BEGIN
      K:= 0;
      FOR I:= X1 TO X2 DO FOR J:= Y1 TO Y2 DO BEGIN
          Tab[K]:= GetChar(I,J);
          Tab[K+1]:= GetCharAttr(I,J);
          K:= K+2;
      END;
 END;

 PROCEDURE SetScr;
 VAR I,J,K : WORD;
 BEGIN
      K:= 0;
      FOR I:= X1 TO X2 DO FOR J:= Y1 TO Y2 DO BEGIN
          TColor(GetCharTextColor(Tab[K+1]),GetCharBackground(Tab[K+1]));
          TWrite(Chr(Tab[K]),I,J);
          K:= K+2;
      END;
 END;

 PROCEDURE ClearKbdBuf;
 BEGIN
      CLI;
      MemW[$40:$1A]:= MemW[$40:$1C];
      STI;
 END;

 PROCEDURE Delay;
 VAR Regs : Registers;
 BEGIN
      Temps:= Temps*1000;
      Regs.AH:= $86; Regs.DX:= WORD(Temps); Regs.CX:= Temps SHR 16;
      Intr($15, Regs);
 END;

 PROCEDURE Bh;
 VAR I,J,Ligne1,Ligne2 : BYTE;
     Scr1,Scr2 : ^ScrTab;
 BEGIN
      Ligne1:= 1; Ligne2:= TScreenSize.Y;
      New(Scr1); New(Scr2);
      TColor(0,0);
      FOR I:= (Ligne2-Ligne1) DIV 2 TO Ligne2 DO BEGIN
          GetScr(Ligne1+1,1,(Ligne2-Ligne1) DIV 2,TScreenSize.X,Scr1^);
          GetScr((Ligne2-Ligne1) DIV 2,1,Ligne2-1,TScreenSize.X,Scr2^);
          TMkSpace(1,TScreenSize.X,(Ligne2-Ligne1) DIV 2);
          SetScr(Ligne1,1,(Ligne2-Ligne1) DIV 2-1,TScreenSize.X,Scr1^);
          SetScr((Ligne2-Ligne1) DIV 2+1,1,Ligne2,TScreenSize.X,Scr2^);
          Delay(3);
      END;
      Dispose(Scr1); Dispose(Scr2);
 END;

 PROCEDURE SetRepeatFrequency;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $3; Regs.AL:= $5; Regs.BH:= R; Regs.BL:= F;
      Intr($16, Regs);
 END;

 PROCEDURE SetFlag;
 VAR BiosTSByte : BYTE ABSOLUTE $0040:$0017;
     Regs       : Registers;
 BEGIN
      BiosTSByte:= BiosTSByte OR Flag;
      Regs.AH:= 1;
      Intr($16, Regs);
 END;

 PROCEDURE ClrFlag;
 VAR BiosTSByte : BYTE ABSOLUTE $0040:$0017;
     Regs       : Registers;
 BEGIN
      BiosTSByte:= BiosTSByte AND (NOT Flag);
      Regs.AH:= 1;
      Intr($16, Regs);
 END;

 PROCEDURE SetTextMode(ModeNum : BYTE);
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $00; Regs.AL:= ModeNum;
      Intr($10, Regs);
      GetCurTextModeInfo(CrtPlusVGAVideoBuf);
      TScreenSize.X:= CrtPlusVGAVideoBuf^.NbColonnes;
      TScreenSize.Y:= CrtPlusVGAVideoBuf^.NbLignes;
      SetIntensity(High);
      HideCursor;
 END;

 FUNCTION WaitForKey;
 VAR Ch : Char;
 BEGIN
      Ch:= ReadKey;
      IF Ch = #27 THEN WaitForKey:= True ELSE WaitForKey:= False;
      IF Ch = #0 THEN Ch:= ReadKey;
 END;

 FUNCTION InitMouse;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $0000; Intr($33, Regs);
      IF Regs.AX = $FFFF THEN InitMouse:= TRUE ELSE InitMouse:= FALSE;
 END;

 PROCEDURE SaveCursorSize;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $3; Regs.BH:= 0;
      Intr($10, Regs);
      OldCursSize.X:= Regs.CH;
      OldCursSize.Y:= Regs.CL;
 END;

 PROCEDURE ShowCursor;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $1; Regs.CH:= OldCursSize.X; Regs.CL:= OldCursSize.Y;
      Intr($10, Regs);
 END;

 PROCEDURE HideCursor;
 VAR Regs : Registers;
 BEGIN
      SaveCursorSize;
      Regs.AH:= $1; Regs.CH:= 1; Regs.CL:= 0;
      Intr($10, Regs);
 END;

 PROCEDURE SetCursorSize;
 VAR Regs : Registers;
 BEGIN
      SaveCursorSize;
      Regs.AH:= $1; Regs.CH:= X1; Regs.CL:= Y1;
      Intr($10, Regs);
 END;

 PROCEDURE ShowMouse;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $0001; Intr($33, Regs);
 END;

 PROCEDURE HideMouse;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $0002; Intr($33, Regs);
 END;

 PROCEDURE SetMouseArea; {En pixels}
 VAR Regs : Registers;
 BEGIN
      {En mode texte 80x25, il faut faire (X1-1)*8, et de mme pour X2}
      Regs.AX:= $0007; Regs.CX:= X1; Regs.DX:= X2;
      Intr($33, Regs);
      Regs.AX:= $0008; Regs.CX:= Y1; Regs.DX:= Y2;
      Intr($33, Regs);
 END;

 PROCEDURE SetMouseSensibility;
 VAR Regs : Registers;
 BEGIN
      Regs.AX:= $001A; Regs.DX:= 50;
      Regs.BX:= HSensibility;
      Regs.CX:= VSensibility;
      Intr($33, Regs);
 END;

 PROCEDURE GetMousePosEvent;
 VAR regs : Registers;
 BEGIN
      Regs.AX:= $0003;
      Intr($33, Regs);
      X:= Regs.CX; Y:= Regs.DX;
      IF IsBitSet(Regs.BX,0) THEN G:= TRUE ELSE G:= FALSE;
      IF IsBitSet(Regs.BX,1) THEN D:= TRUE ELSE D:= FALSE;
      IF IsBitSet(Regs.BX,2) THEN M:= TRUE ELSE M:= FALSE;
 END;

 PROCEDURE SetMousePos;
 VAR regs : Registers;
 BEGIN
      Regs.AX:= $0004;
      Regs.CX:= X; Regs.DX:= Y;
      Intr($33, Regs);
 END;

 PROCEDURE SetIntensity;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $10; Regs.AL:= $3;
      CASE Int OF
           High : Regs.BL:= 0;
           Low  : Regs.BL:= 1;
      END;
      Intr($10, Regs);
      Intense:= Int;
 END;

 PROCEDURE TSetColor;
 VAR RGB  : ARRAY [0..2] OF BYTE;
     Regs : Registers;
 BEGIN
      IF ColorNum > 7 THEN ColorNum:= ColorNum+48;
      RGB[0]:= Red; RGB[1]:= Green; RGB[2]:= Blue;
      Regs.AX:= $1012;
      Regs.BX:= ColorNum;
      Regs.CX:= 1;
      Regs.ES:= Seg(RGB);
      Regs.DX:= Ofs(RGB);
      Intr($10, Regs);
 END;

 PROCEDURE TGetColor;
 VAR Regs : Registers;
 BEGIN
      IF ColorNum > 7 THEN ColorNum:= ColorNum+48;
      Regs.AX:= $1015;
      Regs.BX:= ColorNum;
      Intr($10, Regs);
      Red:= Regs.DH;
      Green:= Regs.CH;
      Blue:= Regs.CL;
 END;

 PROCEDURE SetBorderColor;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $10; Regs.AL:= $1; Regs.BH:= Couleur;
      Intr($10, Regs);
 END;

 PROCEDURE Play;
 VAR OldPort61hValue : BYTE;
 BEGIN
      Port[$43]:= 182;
      Port[$42]:= BYTE(1193180 DIV Freq);
      Port[$42]:= (1193180 DIV Freq) SHR 8;
      OldPort61hValue:= Port[$61];
      Port[$61]:= OldPort61hValue OR 3;
      Delay(Temps);
      Port[$61]:= OldPort61hValue;
 END;

 PROCEDURE SetCharWidth(Largeur : BYTE);
 VAR Regs : Registers;
     X    : BYTE;
 BEGIN
      {Uniquement mode texte 80x25}
      IF Largeur = 8 THEN Regs.BX:= $0001 ELSE Regs.BX:= $0800;
      X:= Port[$3CC] AND NOT (4+8);
      IF Largeur = 9 THEN X:= X OR 4;
      Port[$3C2]:= X;
      CLI;
      PortW[$3C4]:= $0100;
      PortW[$3C4]:= $01 + Regs.BL SHL 8;
      PortW[$3C4]:= $0300;
      STI;

      Regs.AX:= $1000;
      Regs.BL:= $13;
      Intr($10, Regs);
 END;

 PROCEDURE TWFromTo;
 VAR I : BYTE;
 BEGIN
      FOR I:= Col1 TO Col2 DO TWrite(Ch, Ligne,I);
 END;

 PROCEDURE Clear;
 VAR I,J : BYTE;
 BEGIN
      FOR I:= 1 TO TScreenSize.Y DO FOR J:= 1 TO TScreenSize.X DO TWrite(' ', I,J);
 END;

 PROCEDURE SetCursorPos;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $02; Regs.BH:= 0; Regs.DH:= X1-1; Regs.DL:= Y1-1;
      Intr($10, Regs);
 END;

 PROCEDURE Bip;
 BEGIN
      Delay(500); Sound(950); Delay(150); NoSound;
 END;

 PROCEDURE TColor;
 { APPLIQUE LES ATTRIBUTS DE COULEURS SPECIFIES }
 BEGIN
      CrtPlus.TxtColor.Y:= TxtGround; CrtPlus.TxtColor.X:= TxtColor;
      IF (Intense = Low) AND (TxtGround > 7) THEN CrtPlus.TxtColor.Y:= TxtGround-Brill;
 END;

 PROCEDURE TLoadPalette;
 VAR I       : BYTE;
 BEGIN
      FOR I:= 0 TO 15 DO
        TSetColor(I, Palette[I].R,Palette[I].V,Palette[I].B);
 END;

 PROCEDURE Quit;
 BEGIN
      SetTextMode(3); SetCursorSize(15,16); ClearKbdBuf; Halt;
 END;

 PROCEDURE TCenter;
 { CENTRE UN TEXTE SUR L'ECRAN }
 VAR Col : BYTE;
 BEGIN
      Col:= (TScreenSize.X+2-Length(Chaine)) DIV 2;
      TWrite(Chaine, Ligne,Col);
 END;

 PROCEDURE TCenterXY;
 VAR Col : BYTE;
 BEGIN
      IF Length(Chaine) > Col2-Col1+1 THEN Chaine:= Copy(Chaine,1,Col2-Col1+1);
      Col:= ((Col2+Col1+2)-Length(Chaine)) DIV 2;
      TWrite(Chaine, Ligne,Col);
 END;

 PROCEDURE TLeftText;
 VAR CurWord : STRING;
     Ligne, Col, I, Pos : BYTE;

 BEGIN
      IF Text[Length(Text)] <> ' ' THEN Text:= Text+' ';
      Ligne:= X1; Col:= Y1;
      Pos:= 1;
      WHILE Pos <= Length(Text) DO BEGIN
            I:= Pos;
            WHILE Text[I] <> ' ' DO
            I:= I+1;
            CurWord:= Copy(Text,Pos,I-Pos);
            IF Col+Length(CurWord) <= Y2 THEN TWrite(CurWord, Ligne,Col) ELSE BEGIN
               Ligne:= Ligne + 1;
               IF Ligne > X2 THEN Break;
               Col:= Y1;
               TWrite(CurWord, Ligne,Col);
            END;
            Pos:= Pos+Length(CurWord)+1;
            Col:= Col+Length(CurWord)+1;
      END;
 END;

 PROCEDURE TCenterText;
 VAR CurWord, Phrase : STRING;
     Ligne, Col, I, Pos : WORD;

 BEGIN
      IF Text[Length(Text)] <> ' ' THEN Text:= Text+' ';
      Ligne:= X1; Col:= Y1;
      Pos:= 1; Phrase:= '';
      WHILE Pos <= Length(Text) DO BEGIN
            I:= Pos;
            WHILE Text[I] <> ' ' DO
            I:= I+1;
            CurWord:= Copy(Text,Pos,I-Pos);
            IF Col+Length(CurWord) <= Y2 THEN Phrase:= Phrase+' '+CurWord ELSE BEGIN
               TCenterXY(Phrase, Ligne,Y1,Y2);
               Ligne:= Ligne + 1;
               IF Ligne > X2 THEN Break;
               Col:= Y1;
               Phrase:= CurWord;
            END;
            Pos:= Pos+Length(CurWord)+1;
            Col:= Col+Length(CurWord)+1;
      END;
      IF Pos >= Length(Text) THEN TCenterXY(Phrase, Ligne,Y1,Y2);
 END;

 PROCEDURE HorizSeparateur;
 VAR I : BYTE;
 BEGIN
      TWrite(#180,Ligne,X2);
      TWrite(#195,Ligne,X1);
      FOR I:= X1+1 TO X2-1 DO TWrite(#196,Ligne,I);
 END;

 PROCEDURE VertSeparateur;
 VAR I : BYTE;
 BEGIN
      TWrite(#194,X1,Colonne);
      TWrite(#193,X2,Colonne);
      FOR I:= X1+1 TO X2-1 DO TWrite(#179,I,Colonne);
 END;

 PROCEDURE TDrawBox;
 { DESSINE UNE BOITE SUR L'ECRAN AVEC/SANS OMBRE }
 VAR I, J : BYTE;
 BEGIN
      TColor(TxtColor,TxtGround);
      CASE ST OF
           Single : BEGIN
                  TWrite('', X1,Y1);
                  TWrite('', X1,Y2);
                  TWrite('', X2,Y1);
                  TWrite('', X2,Y2);
           END;
           Double : BEGIN
                  TWrite(#201, X1,Y1);
                  TWrite(#187, X1,Y2);
                  TWrite(#200, X2,Y1);
                  TWrite(#188, X2,Y2);
           END;
           Solid  : BEGIN
                  TWrite(#219, X1,Y1);
                  TWrite(#219, X1,Y2);
                  TWrite(#219, X2,Y1);
                  TWrite(#219, X2,Y2);
           END;
           HDouble  : BEGIN
                  TWrite(#213, X1,Y1);
                  TWrite(#184, X1,Y2);
                  TWrite(#212, X2,Y1);
                  TWrite(#190, X2,Y2);
           END;
           VDouble  : BEGIN
                  TWrite(#214, X1,Y1);
                  TWrite(#183, X1,Y2);
                  TWrite(#211, X2,Y1);
                  TWrite(#189, X2,Y2);
           END;
           NoBorder : BEGIN
                  TWrite(' ', X1,Y1);
                  TWrite(' ', X1,Y2);
                  TWrite(' ', X2,Y1);
                  TWrite(' ', X2,Y2);
           END;
           UserDefinedBorder : BEGIN
                  TWrite(UserBorder[0], X1,Y1);
                  TWrite(UserBorder[2], X1,Y2);
                  TWrite(UserBorder[6], X2,Y1);
                  TWrite(UserBorder[4], X2,Y2);
           END;
      END;

      FOR I:= Y1+1 TO Y2-1 DO
          CASE ST OF
               Single : BEGIN
                      TWrite(#196, X1,I);
                      TWrite(#196, X2,I);
               END;
               VDouble: BEGIN
                      TWrite(#196, X1,I);
                      TWrite(#196, X2,I);
               END;
               Double : BEGIN
                      TWrite(#205, X1,I);
                      TWrite(#205, X2,I);
               END;
               HDouble: BEGIN
                      TWrite(#205, X1,I);
                      TWrite(#205, X2,I);
               END;
               Solid  : BEGIN
                      TWrite(#223, X1,I);
                      TWrite(#220, X2,I);
               END;
               NoBorder : BEGIN
                      TWrite(' ', X1,I);
                      TWrite(' ', X2,I);
               END;
               UserDefinedBorder : BEGIN
                      TWrite(UserBorder[1], X1,I);
                      TWrite(UserBorder[5], X2,I);
               END;
      END;

      FOR I:= X1+1 TO X2-1 DO
          CASE ST OF
               Single : BEGIN
                      TWrite(#179, I,Y1);
                      TWrite(#179, I,Y2);
               END;
               HDouble: BEGIN
                      TWrite(#179, I,Y1);
                      TWrite(#179, I,Y2);
               END;
               Double : BEGIN
                      TWrite(#186, I,Y1);
                      TWrite(#186, I,Y2);
               END;
               VDouble: BEGIN
                      TWrite(#186, I,Y1);
                      TWrite(#186, I,Y2);
               END;
               Solid  : BEGIN
                      TWrite(#221, I,Y1);
                      TWrite(#222, I,Y2);
               END;
               NoBorder : BEGIN
                      TWrite(' ', I,Y1);
                      TWrite(' ', I,Y2);
               END;
               UserDefinedBorder : BEGIN
                      TWrite(UserBorder[7], I,Y1);
                      TWrite(UserBorder[3], I,Y2);
               END;
      END;

      FOR I:= X1+1 TO X2-1 DO FOR J:= Y1+1 TO Y2-1 DO TWrite(' ', I,J);

      IF Ombre = On THEN BEGIN
         TColor(8,0);
         FOR I:= X1+1 TO X2+1 DO Mem[SegB800:(TScreenSize.X*(I-1)+(Y2))*2+1]:= 8;
         FOR I:= X1+1 TO X2+1 DO Mem[SegB800:(TScreenSize.X*(I-1)+(Y2+1))*2+1]:= 8;
         FOR I:= Y1+2 TO Y2+2 DO Mem[SegB800:(TScreenSize.X*(X2)+(I-1))*2+1]:= 8;
      END;
 END;

 PROCEDURE TBp;
 VAR X,Y,I : -10..255;
 BEGIN
      X:= (X2-X1) DIV 2; Y:= (Y2-Y1) DIV 2;
      IF X > Y THEN BEGIN
         I:= Y;
         REPEAT
            TDrawBox(X1+I,Y1+I,X2-I,Y2-I, Ct,Cb, Off,St);
            Delay(50);
            I:= I-5;
            UNTIL (X1+I<=X1) OR (Y1+I<=Y1);
      END ELSE BEGIN
         I:= X;
         REPEAT
            TDrawBox(X1+I,Y1+I,X2-I,Y2-I, Ct,Cb, Off,St);
            Delay(50);
            I:= I-5;
            UNTIL (X1+I<=X1) OR (Y1+I<=Y1);
      END;
      TDrawBox(X1,Y1,X2,Y2, CT,CB, Ombre, St);
 END;

 PROCEDURE InvBP;
 VAR X,Y,I : -10..255;
 BEGIN
      I:= 0; X:=(X2-X1) DIV 2; Y:= (Y2-Y1) DIV 2;
      REPEAT
            TDrawBox(X1+I,Y1+I,X2-I,Y2-I, Ct,Cb, Off,St);
            Delay(25);
            I:= I+1;
      UNTIL (X1+I>=X) OR (Y1+I>=Y);
 END;

 PROCEDURE DrawHScrollBar(Y1,Y2, X : BYTE; BlocPos : BYTE);
 VAR I : BYTE;
 BEGIN
      FOR I:= Y1+2 TO Y2-2 DO TWrite(#242, X,I);
      TWrite(#238#239, X,Y1);
      TWrite(#236#237, X,Y2-1);

      TWrite(#240#241, X, Y1+2+BlocPos);
 END;

 PROCEDURE DrawVScrollBar(X1,X2, Y : BYTE; BlocPos : BYTE);
 VAR I : BYTE;
 BEGIN
      FOR I:= X1+1 TO X2-1 DO TWrite(#253, I,Y);
      FOR I:= X1+1 TO X2-1 DO TWrite(#249, I,Y+1);
      TWrite(#232#233, X1,Y); TWrite(#234#235, X2,Y);

      TWrite(#240#241, X1+1+BlocPos, Y);
 END;

 PROCEDURE VUpScroll;
 VAR I,J : BYTE;
 BEGIN
      FOR I:= X1+1 TO X2 DO FOR J:= Y1 TO Y2 DO BEGIN
          TColor(GetCharTextColor(GetCharAttr(I-1,J)),GetCharBackground(GetCharAttr(I-1,J)));
          TWrite(Chr(GetChar(I,J)),I-1,J);

          TColor(GetCharTextColor(GetCharAttr(I,J)),GetCharBackground(GetCharAttr(I,J)));
          TWrite(' ',I,J);
      END;
 END;

 PROCEDURE VDownScroll;
 VAR I,J : BYTE;
 BEGIN
      FOR I:= X2-1 DOWNTO X1 DO FOR J:= Y1 TO Y2 DO BEGIN
          TColor(GetCharTextColor(GetCharAttr(I+1,J)),GetCharBackground(GetCharAttr(I+1,J)));
          TWrite(Chr(GetChar(I,J)),I+1,J);

          TColor(GetCharTextColor(GetCharAttr(I,J)),GetCharBackground(GetCharAttr(I,J)));
          TWrite(' ',I,J);
      END;
 END;

 PROCEDURE RedefChar;
 VAR Regs : Registers;
     I,J  : BYTE;
     L    : DWORD;
     Car  : ARRAY [1..16] OF BYTE;
 BEGIN
      FOR I:= 1 TO 16 DO Car[I]:= 0;
      Regs.AH:= $11; Regs.AL:= $10; Regs.BH:= Hauteur; Regs.BL:= $00; Regs.CX:= $01; Regs.DX:= Caractere;
      Regs.ES:= Seg(Car); Regs.BP:= Ofs(Car);
      FOR I:= 1 TO Hauteur DO FOR J:= 0 TO 7 DO BEGIN
          L:= Car[I];
          IF Tab[I][J+1] = #219 THEN SetBit(L,7-J) ELSE ClearBit(L,7-J);
          Car[I]:= BYTE(L);
      END;
      Intr($10, Regs);
 END;

 PROCEDURE GetCharForm;
 TYPE CARDEF = ARRAY [0..255, 1..16] OF BYTE;
      CARPTR = ^CARDEF;

 CONST FPtr : CARPTR = NIL;

 VAR  Regs  : Registers;
      CH    : CHAR;
      I, J, Masque : BYTE;

 BEGIN
      IF FPtr = NIL THEN BEGIN
         Regs.AH:= $11;
         Regs.AL:= $30;
         Regs.BH:= 6;
         Intr($10, Regs);
         FPtr:= Ptr(Regs.ES,Regs.BP);
      END;

      FOR I:= 1 TO 16 DO BEGIN
          Masque:= FPtr^[Ord(Caractere),I];
          FOR J:= 1 TO 8 DO BEGIN
              IF Masque AND 128 = 128 THEN CH:= #219 ELSE CH:= #32;
              CharTab[I]:= CharTab[I]+' ';
              CharTab[I,J]:= Ch;
              Masque:= Masque SHL 1;
          END;
      END;
 END;

 PROCEDURE TMkSpace;
 { PLACE UN VIDE A PARTIR DE LA COLONNE DE DEBUT JUSQU'A CELLE DE LA FIN
   SUR UNE LIGNE INDIQUEE }
 VAR I : BYTE;
 BEGIN
      FOR I:= Y1 TO Y2 DO TWrite(' ', Ligne, I);
 END;

 PROCEDURE TWrite;
 VAR I : BYTE;
 BEGIN
      FOR I:= 1 TO Length(Chaine) DO IF ((Colonne+I-1) <= TScreenSize.X) AND (Ligne <= TScreenSize.Y) THEN BEGIN
          Mem[SegB800:(TScreenSize.X*(Ligne-1)+(Colonne+I-2))*2]:= Ord(Chaine[I]);
          Mem[SegB800:(TScreenSize.X*(Ligne-1)+(Colonne+I-2))*2+1]:= TxtColor.X+TxtColor.Y*16;
      END;
 END;

 PROCEDURE TruncStr;
 { PERMET LA TRONCATURE D'UNE CHAINE DE CARACTERES A UNE NOMBRE
   DE CARACTERES FOURNIT }
 VAR Tempo : STRING;
     J     : BYTE;
 BEGIN
      Tempo:= Chaine;
      Chaine:='';
      FOR J:=1 TO Longueur DO BEGIN
          Chaine:= Chaine+' ';
          Chaine[J]:= Tempo[J];
      END;
 END;

 PROCEDURE DelChar;
 { SUPPRIME LE CARACTERE INDIQUE D'UNE CHAINE PUIS DECALE D'UNE
   POSITION CE QUI RESTE }
 VAR Tempo : STRING;
 BEGIN
      Tempo:= Chaine;
      TruncStr(Position-1, Chaine);
      Chaine:= Chaine + Copy(Tempo, Position+1, 254);
 END;

 PROCEDURE InsChar;
 { PERMET D'INSERER UN CARACTERE DANS UNE CHAINE A LA POSITION INDIQUEE }
 VAR Tempo : STRING;
 BEGIN
      Tempo:= Chaine;
      TruncStr(Position-1, Chaine);
      Chaine:= Chaine + Ch + Copy(Tempo, Position, 254);
 END;

 FUNCTION ExistFile;
 VAR DirInfo : SearchRec;
 BEGIN
      FindFirst(FileName, AnyFile, DirInfo);
      IF DosError <> 0 THEN ExistFile:= False ELSE ExistFile:= True;
 END;

 FUNCTION UpCaseStr;
 VAR I : 1..255;
 BEGIN
      FOR I:= 1 TO Length(Chaine) DO CASE Ord(Chaine[I]) OF
          97..122 : Chaine[I]:= Chr(Ord(Chaine[I])-32);
          130     : Chaine[I]:= Chr(144);
          135     : Chaine[I]:= Chr(128);
      END;
      UpCaseStr:= Chaine;
 END;

 FUNCTION LowCaseStr;
 VAR I : 1..255;
 BEGIN
      FOR I:= 1 TO Length(Chaine) DO IF (Ord(Chaine[I]) >= 65) AND (Ord(Chaine[I]) <= 90) THEN
          Chaine[I]:= Chr(Ord(Chaine[I])+32);
      LowCaseStr:= Chaine;
 END;

 FUNCTION DetectDir;
 VAR I  : BYTE;
 BEGIN
      FOR I:= Length(Path) DOWNTO 1 DO IF (Path[I] = '\') THEN BEGIN
          DetectDir:= Copy(Path,1, I-1);
          Exit;
      END ELSE DetectDir:= '';
 END;

 PROCEDURE P; INTERRUPT;
 BEGIN
 END;

 BEGIN
      New(CrtPlusVGAVideoBuf);
      SetIntVec($1B, @P);
      GetCurTextModeInfo(CrtPlusVGAVideoBuf);
      TScreenSize.X:= CrtPlusVGAVideoBuf^.NbColonnes;
      TScreenSize.Y:= CrtPlusVGAVideoBuf^.NbLignes;
      SetMouseArea(1,1,TScreenSize.X,TScreenSize.Y);
      SetIntensity(High);
      HideCursor;
      SetRepeatFrequency(0,0);
 END.