 {$IFDEF DMPI}
         {$C MOVEABLE DEMANDLOAD DISCARDABLE}
 {$ENDIF}
 UNIT DosPlus;
 {
   UNITE DES E/S FICHIERS
   Sad LANKRI,
   1999 - 2000
 }

 INTERFACE

 TYPE IMAGE_DOS_HEADER = RECORD {En-tte standard pour des fichiers .EXE DOS}
      Magic, CBLP, CP, CRLC, CPARHDR, MinAlloc, MaxAlloc, SS, SP, Sum,
      IP, CS, LFarLc, OverlayNo : WORD;
      Reserved1 : ARRAY[1..4] OF WORD;
      OEMId, OEMInfo : WORD;
      Reserved2 : ARRAY[1..10] OF WORD;
      LFANew : LongInt; {Position de l'en-tte nouvelle (Celle de WIN 95 et+)}
 END;

 TYPE IMAGE_DATA_DIRECTORY = RECORD
      VirtualAddress, Size : LongInt;
 END;

 TYPE IMAGE_FILE_HEADER = RECORD {En-tte pour fichiers .EXE WINDOWS 95 et +}
      Machine, NumberOfSections : WORD;
      TimeDateStamp, PointerToSymbolTable, NumberOfSymbols : LongInt;
      SizeOfOptionalHeader, Characteristics : WORD;
 END;

 TYPE IMAGE_OPTIONAL_HEADER = RECORD {Fichiers .EXE WINDOWS 95 et + (2me partie)}
      Magic : WORD;
      MajorLinkerVersion, MinorLinkerVersion : BYTE;
      SizeOfCode, SizeOfInitializedData, SizeOfUninitializedData,
      AdressOfEntryPoint, BaseOfCode, BaseOfData, ImageBase,
      SectionAlignment, FileAlignment : LongInt;

      MajorOperatingSystemVersion, MinorOperatingSystemVersion,
      MajorImageVersion, MinorImageVersion, MajorSubsystemVersion,
      MinorSubsystemVersion : WORD;

      Reserved1, SizeOfImage, SizeOfHeaders, CheckSum : LongInt;

      Subsystem, DLLCharacteristics : WORD;

      SizeOfStackReserve, SizeOfStackCommit, SizeOfHeapReserve,
      SizeOfHeapCommit, LoaderFlags, NumberOfRVAandSizes : LongInt;

      DataDirectory : ARRAY[1..16] OF IMAGE_DATA_DIRECTORY;
 END;

 TYPE IMAGE_SECTION_HEADER = RECORD {Pour les sections d'un .EXE / .DLL}
      Name : ARRAY [1..8] OF BYTE;
      VirtualSize, VirtualAdress, SizeOfRawData, PointerToRawData,
      PointerToRelocations, PointerToLineNumbers : LongInt;
      NumberOfRelocations, NumberOfLineNumbers : WORD;
      Characteristics : LongInt;
 END;

 TYPE IMAGE_NT_HEADERS = RECORD {Les deux parties}
      Signature : LongInt;
      ImageFileHeader : IMAGE_FILE_HEADER;
      ImageOptionalHeader : IMAGE_OPTIONAL_HEADER;
 END;

 {Pour un exemple d'utilisation de ces en-ttes, voir le programme DumpBin.EXE}

 TYPE FileDateTimeRec = RECORD
      Year, Month, Day : BYTE;
      Hour, Min, Sec   : BYTE;
 END;

 TYPE SysDateRec = RECORD
      Year, Month, Day, DayWeek : WORD;
 END;

 TYPE SysTimeRec = RECORD
      Hour, Min, Sec, Sec100 : WORD;
 END;

 TYPE FileAttrRec = RECORD
      ReadOnly, Hidden, System : BOOLEAN;
 END;


 PROCEDURE CloseFile   (Handle : WORD);
 PROCEDURE SetFilePos  (Handle : WORD; Pos : LongInt);
 PROCEDURE DeleteFile  (Name : STRING);
 PROCEDURE RenameFile  (OldName, NewName : STRING);
 PROCEDURE TruncFile   (Name : STRING; Pos : LongInt);

 PROCEDURE SetFileAttr (Name : STRING; Attr : FileAttrRec);
 PROCEDURE GetFileAttr (Name : STRING; VAR Attr : FileAttrRec);
 PROCEDURE SetFileDateTime (Handle : WORD; DateTime : FileDateTimeRec);
 PROCEDURE GetFileDateTime (Handle : WORD; VAR DateTime : FileDateTimeRec);
 PROCEDURE NewDir          (Name : STRING);
 PROCEDURE DeleteDir       (Name : STRING);
 PROCEDURE CopyFile        (SourceStr, DestStr : STRING);
 PROCEDURE MoveFile        (SourceStr, DestStr : STRING);
 PROCEDURE GetDosVersion   (VAR Primary, Secondary : BYTE);
 PROCEDURE GetDate         (VAR Date : SysDateRec);
 PROCEDURE GetTime         (VAR Time : SysTimeRec);
 PROCEDURE SetDate         (Date : SysDateRec);
 PROCEDURE SetTime         (Time : SysTimeRec);

 FUNCTION  GetDosError : WORD;
 FUNCTION  NewFile     (Name : STRING) : WORD;
 FUNCTION  ReadFile    (Handle : WORD; VAR Buf; CNT : WORD) : WORD;
 FUNCTION  WriteFile   (Handle : WORD; VAR Buf; CNT : WORD) : WORD;
 FUNCTION  GetFileSize (Handle : WORD) : LongInt;
 FUNCTION  OpenFile    (FileName : STRING) : WORD;
 FUNCTION  GetFilePos  (Handle : WORD) : LongInt;

 VAR   IsThereError  : BOOLEAN;
       CurrentError  : WORD;

 CONST NoError       = 0;
       PosOutOfRange = 1;
       FileNotFound  = 2;
       PathNotFound  = 3;
       NoMoreHandles = 4;
       AccessDenied  = 5;
       InvalidHandle = 6;
       NotEnoughMemory = 8;
       UnknownDrive    = 15;
       CantOpenDir     = 16;
       NoMoreFiles     = 18;
       WriteProtected  = 19;
       DriveNotReady   = 21;
       SectorNotFound  = 27;
       WriteError      = 29;
       ReadError       = 30;
       FileAlreadyExists = 80;
       CantCreateDir     = 82;
       InvalidDateTime   = 255;

 IMPLEMENTATION

 USES CrtPlus, Dos, Convert;

 FUNCTION GetDosError;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $59; Regs.BX:= $00;
      Intr($21, Regs);
      GetDosError:= Regs.AX;
 END;

 FUNCTION NewFile;
 VAR Regs : Registers;
 BEGIN
      IsThereError:= FALSE;
      Regs.AH:= $3C;
      Regs.CX:= $00;
      Name:= Name + #0;
      Regs.DS:= Seg(Name);
      Regs.DX:= Ofs(Name) + 1;
      MsDos(Regs);
      IF (Regs.Flags AND 1) = 0 THEN NewFile:= Regs.AX ELSE BEGIN
         IsThereError:= TRUE;
         CurrentError:= GetDosError;
      END;
 END;

 FUNCTION OpenFile;
 VAR Regs : Registers;
 BEGIN
      IsThereError:= FALSE;
      Regs.AH:= $3D;
      Regs.AL:= $2;
      FileName:= FileName + #0;
      Regs.DS:= LongInt(@FileName[1]) SHR 16;
      Regs.DX:= LongInt(@FileName[1]) AND $FFFF;

      MsDos(Regs);
      IF (Regs.Flags AND 1) = 0 THEN OpenFile:= Regs.AX ELSE BEGIN
         IsThereError:= TRUE;
         CurrentError:= GetDosError;
      END;
 END;

 PROCEDURE CloseFile;
 VAR Regs : Registers;
 BEGIN
      IF Handle >= 0 then BEGIN
         Regs.AH:= $3E;
         Regs.BX:= Handle;
         MsDos(Regs);
      END;
 END;

 FUNCTION ReadFile;
 VAR Regs : Registers;
 BEGIN
      IsThereError:= FALSE;
      IF Handle >= 0 THEN BEGIN
         Regs.AH:= $3F;
         Regs.BX:= Handle;
         Regs.CX:= CNT;
         Regs.DS:= Seg(Buf);
         Regs.DX:= Ofs(Buf);
         MsDos(Regs);
         IF (Regs.Flags AND 1) = 0 THEN ReadFile:= Regs.AX ELSE BEGIN
            IsThereError:= TRUE;
            CurrentError:= GetDosError;
         END;
      END;
 END;

 FUNCTION WriteFile;
 VAR Regs : Registers;
 BEGIN
      IF Handle >= 0 THEN BEGIN
         Regs.AH:= $40;
         Regs.BX:= Handle;
         Regs.CX:= CNT;
         Regs.DS:= Seg(Buf);
         Regs.DX:= Ofs(Buf);
         MsDos(Regs);
         IF (Regs.Flags AND 1) = 0 THEN WriteFile:= Regs.AX ELSE BEGIN
            IsThereError:= TRUE;
            CurrentError:= GetDosError;
         END;
      END;
 END;

 FUNCTION GetFileSize;
 VAR Regs : Registers;
     ActPosL, ActPosH : WORD;
 BEGIN
      GetFileSize:= 0;
      IF Handle >= 0 THEN BEGIN
         Regs.AH:= $42;
         Regs.AL:= 1;
         Regs.BX:= Handle;
         Regs.CX:= 0;
         Regs.DX:= 0;
         MsDos(Regs);
         IF Regs.FLags AND 1 = 0 THEN BEGIN
            ActPosL:= Regs.AX;
            ActPosH:= Regs.DX;
         END ELSE Exit;

         Regs.AH:= $42;
         Regs.AL:= 2;
         Regs.BX:= Handle;
         Regs.CX:= 0;
         Regs.DX:= 0;
         MsDos(Regs);
         IF Regs.Flags AND 1 = 0 THEN BEGIN
            GetFileSize:= LongInt(Regs.DX) SHL 16 + LongInt (Regs.AX);
         END ELSE Exit;

         Regs.AH:= $42;
         Regs.AL:= 0;
         Regs.BX:= Handle;
         Regs.CX:= ActPosH;
         Regs.DX:= ActPosL;
         MsDos(Regs);
         IF Regs.Flags AND 1 <> 0 THEN BEGIN
            GetFileSize:= 0;
            Exit;
         END;
      END;
 END;

 FUNCTION GetFilePos;
 VAR Regs : Registers;
 BEGIN
      IF Handle >= 0 THEN BEGIN
         Regs.AH:= $42;
         Regs.AL:= 1;
         Regs.BX:= Handle;
         Regs.CX:= 0;
         Regs.DX:= 0;
         MsDos(Regs);
         IF Regs.FLags AND 1 = 0 THEN GetFilePos:= LongInt(Regs.DX) SHL 16 + LongInt(Regs.AX);
      END;
 END;

 PROCEDURE SetFilePos;
 VAR Regs : Registers;
 BEGIN
      IF Handle >= 0 THEN BEGIN
         Regs.AH:= $42;
         Regs.AL:= 0;
         Regs.BX:= Handle;
         Regs.CX:= Pos SHR 16;
         Regs.DX:= Word(Pos);
         MsDos(Regs);
         IF (Regs.FLags AND 1) = 0 THEN IsThereError:= FALSE ELSE BEGIN
            IsThereError:= TRUE;
            IF Regs.AX = 1 THEN CurrentError:= PosOutOfRange ELSE CurrentError:= GetDosError;
         END;
      END;
 END;

 PROCEDURE DeleteFile;
 VAR Handle : INTEGER;
     Regs   : Registers;
 BEGIN
      IsThereError:= FALSE;
      Name:= Name+#0;
      Regs.AH:= $41;
      Regs.DS:= Seg(Name);
      Regs.DX:= Ofs(Name)+1;
      Intr($21, Regs);

      IF Regs.Flags AND 1 <> 0 THEN BEGIN
         IsThereError:= TRUE;
         CurrentError:= GetDosError;
      END;
 END;

 PROCEDURE RenameFile;
 VAR Regs : Registers;
 BEGIN
      OldName:= OldName+#0; NewName:= NewName+#0;

      Regs.AH:= $56;
      Regs.DS:= Seg(OldName);
      Regs.DX:= Ofs(OldName)+1;
      Regs.ES:= Seg(NewName);
      Regs.DI:= Ofs(NewName)+1;
      Intr($21, Regs);
 END;

 PROCEDURE TruncFile;
 VAR THandle,Handle : INTEGER;
     I       : LongInt;
     Ch      : BYTE;
 BEGIN
      Handle:= OpenFile(Name);
      IF GetFileSize(Handle) <= Pos THEN Exit;
      SetFilePos(Handle,0);
      THandle:= NewFile('0.0');
      FOR I:= 0 TO Pos-1 DO BEGIN
          ReadFile(Handle,Ch,1);
          WriteFile(THandle,Ch,1);
      END;
      CloseFile(Handle);
      CloseFile(THandle);
      DeleteFile(Name);
      RenameFile('0.0',Name);
 END;

 PROCEDURE SetFileDateTime;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $57; Regs.AL:= $01; Regs.BX:= Handle;
      Regs.CX:= DateTime.Sec AND Bin2Dec('00011111');
      Regs.CX:= Regs.CX + ((DateTime.Min AND Bin2Dec('00111111')) SHL 5);
      Regs.CX:= Regs.CX + ((DateTime.Hour AND Bin2Dec('00011111')) SHL 11);

      Regs.DX:= DateTime.Day AND Bin2Dec('00011111');
      Regs.DX:= Regs.DX + ((DateTime.Month AND Bin2Dec('00001111')) SHL 5);
      Regs.DX:= Regs.DX + ((DateTime.Year AND Bin2Dec('01111111')) SHL 9);

      Intr($21, Regs);
 END;

 PROCEDURE GetFileDateTime;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $57; Regs.AL:= $00; Regs.BX:= Handle;
      Intr($21, Regs);

      WITH DateTime DO BEGIN
           Day:= Regs.DX AND 31;
           Month:= (Regs.DX SHR 5) AND 15;
           Year:= (Regs.DX SHR 9) AND 63;

           Sec:= Regs.CX AND 31;
           Min:= (Regs.CX SHR 5) AND 31;
           Hour:= (Regs.CX SHR 11) AND 63;
      END;
 END;

 PROCEDURE SetFileAttr;
 VAR Regs : Registers;
     L    : LongInt;
 BEGIN
      Name:= Name + #0;
      Regs.AH:= $43; Regs.AL:= $01;
      Regs.DS:= Seg(Name); Regs.DX:= Ofs(Name)+1;
      Regs.CX:= 0; L:= 0;

      WITH Attr DO BEGIN
           IF ReadOnly THEN SetBit(L, 0);
           IF Hidden   THEN SetBit(L, 1);
           IF System   THEN SetBit(L, 2);
      END;
      Regs.CX:= WORD(L);

      Intr($21, Regs);
 END;

 PROCEDURE GetFileAttr;
 VAR Regs : Registers;
     L    : LongInt;
 BEGIN
      Name:= Name + #0;
      Regs.AH:= $43; Regs.AL:= $00;
      Regs.DS:= Seg(Name); Regs.DX:= Ofs(Name)+1;
      Intr($21, Regs);

      L:= 0;
      WITH Attr DO BEGIN
           Hidden:= FALSE; ReadOnly:= FALSE; System:= FALSE;
           IF (Regs.CX AND 0) <> 0 THEN ReadOnly:= TRUE;
           IF (Regs.CX AND 2) <> 0 THEN Hidden:= TRUE;
           IF (Regs.CX AND 4) <> 0 THEN System:= TRUE;
      END;
 END;

 PROCEDURE NewDir;
 VAR Regs : Registers;
 BEGIN
      IsThereError:= FALSE;
      Name:= Name + #0;
      Regs.AH:= $39; Regs.DS:= Seg(Name); Regs.DX:= Ofs(Name)+1;
      Intr($21, Regs);
      IF IsBitSet(Regs.Flags, 0) THEN BEGIN
         IsThereError:= TRUE;
         CurrentError:= GetDosError;
      END;
 END;

 PROCEDURE DeleteDir;
 VAR Regs : Registers;
 BEGIN
      IsThereError:= FALSE;
      Name:= Name + #0;
      Regs.AH:= $3A; Regs.DS:= Seg(Name); Regs.DX:= Ofs(Name)+1;
      Intr($21, Regs);
      IF Regs.Flags AND 1 <> 0 THEN BEGIN
         IsThereError:= TRUE;
         CurrentError:= GetDosError;
      END;
 END;

 PROCEDURE GetDosVersion;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $30;
      Intr($21, Regs);
      Primary:= Regs.AL; Secondary:= Regs.AH;
 END;

 PROCEDURE GetDate;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $2A;
      Intr($21, Regs);
      WITH Date DO BEGIN
           DayWeek:= Regs.AL; Day:= Regs.DL; Month:= Regs.DH; Year:= Regs.CX;
      END;
 END;

 PROCEDURE GetTime;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $2C;
      Intr($21, Regs);
      WITH Time DO BEGIN
           Hour:= Regs.CH; Min:= Regs.CL; Sec:= Regs.DH; Sec100:= Regs.DL;
      END;
 END;

 PROCEDURE SetDate;
 VAR Regs : Registers;
 BEGIN
      IsThereError:= FALSE;
      Regs.AH:= $2B;
      WITH Date DO BEGIN
           Regs.CX:= Year; Regs.DH:= Month; Regs.DL:= Day;
      END;
      Intr($21, Regs);
      IF Regs.AL <> 0 THEN BEGIN
         IsThereError:= TRUE;
         CurrentError:= InvalidDateTime;
      END;
 END;

 PROCEDURE SetTime;
 VAR Regs : Registers;
 BEGIN
      IsThereError:= FALSE;
      Regs.AH:= $2D;
      WITH Time DO BEGIN
           Regs.CH:= Hour; Regs.CL:= Min; Regs.DH:= Sec; Regs.DL:= Sec100;
      END;
      Intr($21, Regs);
      IF Regs.AL <> 0 THEN BEGIN
         IsThereError:= TRUE;
         CurrentError:= InvalidDateTime;
      END;
 END;

 PROCEDURE CopyFile;
 TYPE Buffer = ARRAY[1..16384] OF BYTE;
      PBuf   = ^Buffer;
 VAR Buf : PBuf;
     Source,Dest : WORD;
     Size        : DWORD;
 BEGIN
      Source:= OpenFile(SourceStr);
      IF IsThereError THEN Exit;
      Dest:= NewFile(DestStr);
      IF IsThereError THEN BEGIN
         CloseFile(Source);
         Exit;
      END;
      New(Buf);
      WHILE GetFilePos(Source) <= GetFileSize(Source)-1 DO BEGIN
            IF GetFileSize(Source)-GetFilePos(Source)-1 >= 16384 THEN BEGIN
               ReadFile(Source, Buf^, 16384);
               WriteFile(Dest, Buf^, 16384);
            END ELSE BEGIN
               Size:= DWORD(GetFileSize(Source))-DWORD(GetFilePos(Source));
               ReadFile(Source, Buf^, Size);
               WriteFile(Dest, Buf^, Size);
            END;
      END;

      CloseFile(Source); CloseFile(Dest);
      Dispose(Buf);
 END;

 PROCEDURE MoveFile;
 BEGIN
      CopyFile(SourceStr, DestStr);
      IF IsThereError THEN Exit;
      DeleteFile(SourceStr);
 END;

 BEGIN
 END.