 {$IFDEF DMPI}
         {$C MOVEABLE DEMANDLOAD DISCARDABLE}
 {$ENDIF}
 UNIT GrPlus;
 {
   UNITE POUR GERER LES ROUTINES D'ECRAN EN MODE GRAPHIQUE VESA
   Sad LANKRI,
   1999 - 2000

   Dernire MAJ : 04/10/01

   REMARQUES :
           * LA PLUPART DES PROCEDURES DE TEXTE (Centrer, justifier,
           aligner...) NECESSITENT QU'UNE FONTE SOIT CHARGEE ET DU MODE
           VirtualScreen, A L'EXEPTION DE GWrite QUI FONCTIONNE DANS LES
           DEUX MODES : RealScreen, VirtualScreen.
           * LES FONTES CHARGEES DOIVENT ETRE COMPATIBLES AVEC LA PROCEDURE
           POUR CELA, CONCEVEZ-LES AVEC CreaFont Version 1.0.

   AVERTISSEMENT :
           * NECESSITE UNE CARTE GRAPHIQUE VESA (SUPER VGA)
           * LA PROCEDURE GetModeInfo; Near; NE RENVOIE AUCUNE INFORMATION
           EN MODE PROTEGE, VOUS DEVEZ REMPLIR LES CHAMPS DE ModeInfo
           VOUS-MEMES.

   Enfin PutPixel est corrige ! (et avec GetPixel)
 }

 INTERFACE

 USES Crt, Dos, CrtPlus, DosPlus, Convert;

 TYPE FillType = (Empty, Full);
      BType    = (Inn, Out);
      TFontBuf    = ARRAY [1..65535] OF BYTE;
      TScr        = ARRAY [0..1023]  OF BYTE;
      TScrW       = ARRAY [0..1023]  OF WORD;
      TWriteMode  = (RealScreen, VirtualScreen);

      Font_Header = RECORD              {En-tte de la fonte}
                  Name : STRING;
                  Copyright : STRING;
                  PVer, SVer, Width, Height, NormalSize : BYTE;
      END; {Compatible CreaFont V1.0}

 TYPE GVGAVideoBuf = RECORD    {Infos retournes par le BIOS VESA
                                   sur un mode VESA bien prcis}
      ModeFlag : WORD;
      Flag1, Flag2 : BYTE;
      Granularity, WindowsSize, WindowSeg1, WindowSeg2 : WORD;
      VisibleArea : DWORD;
      NbBytesOccupiedPerLine, ResX, ResY : WORD;
      Largeur, Hauteur, NbPlanBits, NbBitsPoint, NbBlocks, ModeleMemoire, BlockSize,
      NbPagesImage, Reserved : BYTE;

      {Nouveau champs si modle mmoire = 6 ou = 7}
      RedMaskLength,RedMaskPos,
      GreenMaskLength,GreenMaskPos,
      BlueMaskLength,BlueMaskPos,
      ReservedMaskLength,ReservedMaskPos,
      DirectColorAttribute,
      ResteBloc : BYTE;
 END;

 TYPE VESA_ESSENTIAL_INFO = RECORD  {Infos retournes par le BIOS VESA
                                     sur la carte graphique (en gnral)}
      Signature : ARRAY[1..4] OF BYTE;
      MajorVer, MinorVer : BYTE;
      Manufacturer, CardPerformance, ModePtr : DWORD;
      NbChunks : WORD;
      Reserved : ARRAY[1..236] OF BYTE;
 END;

 TYPE T3DPoint = RECORD
      X,Y,Z : INTEGER;
 END;


 CONST FontSignature = 22;          {Taille de la signature qui introduit
                                     une fonte}
 VAR InGraph   : BOOLEAN;  {En mode graphique ?}
     IsLoaded  : BOOLEAN;  {Fonte en mmoire ?}
     GScreenSize : TPoint;          {Taille relle de l'cran}
     CP         : T3DPoint;           {Coordonnes de la dernire position}
     PointDeFuite : T3DPoint;       {Coordonnes point de fuite}
     LineStyle  : STRING;           {Style de ligne : 1 allum, 0 teint
                                    n'affecte que Line et drives}
     GrPlusVGAVideoBuf : GVGAVideoBuf; {Infos sur le mode VESA courant}
     FontHandle : INTEGER;          {Handle de la fonte}
     FontHeader : Font_Header;      {et son en-tte}
     VesaInf    : VESA_ESSENTIAL_INFO;
     GUserBorder : UserBorderTab;
     CurWindow : BYTE;     {Numro de la fentre d'accs RAM}

 FUNCTION  IsVesa  : BOOLEAN; FAR;

 PROCEDURE SetVESAMode (ModeNo : WORD); FAR;

 FUNCTION GetModeNum(X,Y,C : WORD) : WORD;

 FUNCTION  GetMaxX : WORD;
 FUNCTION  GetMaxY : WORD;

 PROCEDURE Window       (X11,Y11,X22,Y22 : WORD);
 PROCEDURE SetWriteMode (WM : TWriteMode);
 FUNCTION  GetWriteMode  : TWriteMode;

 PROCEDURE UnLoadFont;
 PROCEDURE LoadFont     (Name : STRING);

 FUNCTION  GetCharWidth  : BYTE;
 FUNCTION  GetCharHeight : BYTE;

 PROCEDURE PutPixel  (X,Y : INTEGER; GColor : LongInt);
 PROCEDURE Box       (X1,Y1, X2,Y2 : WORD; GColor : WORD; Fill : FillType);
 PROCEDURE Line      (X1,Y1, X2,Y2 : INTEGER; GColor : LongInt);
 PROCEDURE LineTo    (X,Y : INTEGER; GColor : LongInt);
 PROCEDURE GSetColor  (Red, Green, Blue : BYTE; ColorNum : WORD);
 PROCEDURE GGetColor  (VAR Red,Green,Blue : BYTE; ColorNum : WORD);
 PROCEDURE Circle    (X,Y,R : LongInt; GColor : LongInt);
 PROCEDURE Ellipse   (X,Y, XR,YR : LongInt; GColor : LongInt);
 PROCEDURE MoveTo    (X,Y : WORD);
 PROCEDURE GetXYCoords (VAR X,Y : INTEGER; Z : INTEGER);
 PROCEDURE PutPixel3D  (X,Y,Z : WORD; Color : DWORD);
 PROCEDURE Line3D      (X1,Y1,Z1, X2,Y2,Z2 : WORD; Color : DWORD);
 PROCEDURE LineTo3D    (X,Y,Z : WORD; Color : DWORD);

 FUNCTION  GetColorIndex (R,V,B,Alpha : BYTE) : DWORD;
 FUNCTION  GetPixel      (X,Y : INTEGER) : LongInt;
 FUNCTION  GetMaxColor   : LongInt;

 PROCEDURE GWrite       (S : STRING; X,Y : WORD);
 PROCEDURE GColor       (X,Y : WORD);
 PROCEDURE GCenter      (S : STRING; Ligne : WORD);
 PROCEDURE GetWindow    (VAR CurWindowPos : TRect);

 PROCEDURE GMkSpace   (Y1,Y2, Ligne : WORD);
 PROCEDURE GWFromTo   (Ch : Char; Col1,Col2, Ligne : WORD);
 PROCEDURE GDrawBox  (X1,Y1, X2,Y2, TxtColor,TxtGround : WORD; St : BorderType);
 PROCEDURE Bouton (X1,Y1,X2,Y2 : WORD; C : WORD; FillType : FillType; BoutonType : BType);
 PROCEDURE DLine  (X1,Y1,X2,Y2 : WORD; C : WORD);
 PROCEDURE GCenterXY   (Chaine : STRING; Col1,Col2,Ligne : WORD);
 PROCEDURE GLeftText   (Text : STRING; Y1,X1,Y2,X2 : WORD);
 PROCEDURE GCenterText (Text : STRING; Y1,X1,Y2,X2 : WORD);
 PROCEDURE GetGraphModeInfo(Mode : WORD; Buf : POINTER);
 PROCEDURE SetWindowAccess(Offset : WORD); FAR;

 IMPLEMENTATION

 VAR CurMode   : WORD;     {Numro du mode courant}

     FontBuf   : ^TFontBuf;
     TC,TB     : WORD;     {Couleur texte,fond}
     Rect      : TRect;    {Ecran virtuel de travail}
     WriteMode : TWriteMode; {Mode d'affichage par rapport aux coordonnees
                              relles ou virtuelles}

 FUNCTION IsVESA;
 VAR Regs    : Registers;
 BEGIN
      Regs.AH:= $4F; Regs.AL:= $00; Regs.ES:= Seg(VesaInf); Regs.DI:= Ofs(VesaInf);
      Intr($10, Regs);
      IF (Regs.AL = $4F) AND (Regs.AH = $00) THEN IsVesa:= TRUE ELSE IsVesa:= FALSE;
 END;

 PROCEDURE GetGraphModeInfo;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $4F; Regs.AL:= $01; Regs.CX:= Mode;
      Regs.ES:= DWORD(Buf) SHR 16; Regs.DI:= WORD(Buf);
      Intr($10, Regs);
      IsLoaded:= FALSE;
 END;

 FUNCTION GetModeNum;
 VAR Buf : ^GVGAVideoBuf;
     J   : WORD;
 BEGIN
      New(Buf);
      GetModeNum:= 0;
      IsVESA;
      J:= 0;
      WHILE MemW[VesaInf.ModePtr SHR 16 : WORD(VesaInf.ModePtr)+J] <> $FFFF DO BEGIN
            GetGraphModeInfo(MemW[VesaInf.ModePtr SHR 16 : WORD(VesaInf.ModePtr)+J], Buf);
            IF (Buf^.ResX = X) AND (Buf^.ResY = Y) AND (Buf^.NbBitsPoint = C) THEN
              GetModeNum:= MemW[VesaInf.ModePtr SHR 16 : WORD(VesaInf.ModePtr)+J];

            J:= J+2;
      END;
      Dispose(Buf);
 END;

 PROCEDURE SetVESAMode;
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $4F; Regs.AL:= $02; Regs.BX:= ModeNo;
      Intr($10, Regs);
      CurMode:= ModeNo;
      GetGraphModeInfo(CurMode, @GrPlusVGAVideoBuf);
      GScreenSize.X:= GrPlusVGAVideoBuf.ResX-1;
      GScreenSize.Y:= GrPlusVGAVideoBuf.ResY-1;
      InGraph:= TRUE;
      Window(0,0,GetMaxX,GetMaxY);
      SetWriteMode(RealScreen);
 END;

 PROCEDURE SetWindowAccess(Offset : WORD);
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $4F; Regs.AL:= $05; Regs.BH:= $00; Regs.BL:= 0; Regs.DX:= Offset;
      Intr($10,Regs);
 END;

 FUNCTION GetColorIndex;
 {Pas au point pour 24 et 32 bits}
 BEGIN
      CASE GrPlusVGAVideoBuf.NbBitsPoint OF
           15 : BEGIN
              B:= B AND Bin2Dec('11111');
              V:= V AND Bin2Dec('11111');
              R:= R AND Bin2Dec('11111');
              GetColorIndex:= B+V SHL 5+R SHL 10;
                END;
           16 : BEGIN
              B:= B AND Bin2Dec('11111');
              V:= V AND Bin2Dec('111111');
              R:= R AND Bin2Dec('11111');
              GetColorIndex:= B+V SHL 5+R SHL 11;
                END;
           24 : GetColorIndex:= B+V SHL 8+R SHL 16;
           32 : GetColorIndex:= B+V SHL 8+R SHL 16+Alpha SHL 24;
      END;
 END;

(* PROCEDURE PutPixel;
 VAR Orig, Dest, NbBloc : LongInt;
 BEGIN
      IF (X > GetMaxX) OR (Y > GetMaxY) OR (X < 0) OR (Y < 0) THEN Exit;

      Cp.X:= X; Cp.Y:= Y;

      NbBloc:= ((Y*(GrPlusVGAVideoBuf.NbBitsPoint DIV 8) * (GetMaxX+1))+(X*GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+1) DIV
        (GrPlusVGAVideoBuf.Granularity*LongInt(1024));
      IF NbBloc <> CurWindow THEN BEGIN
         CurWindow:= NbBloc;
         SetWindowAccess(NbBloc);
      END;
      Orig:= Y*(GrPlusVGAVideoBuf.NbBitsPoint DIV 8) * (GetMaxX+1)+(X*GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+1;
      Dest:= Orig-((NbBloc)*(GrPlusVGAVideoBuf.Granularity*LongInt(1024)));

      IF Dest >= 1 THEN CASE (GrPlusVGAVideoBuf.NbBitsPoint DIV 8) OF
           1 : Mem[SegA000:Dest-(GrPlusVGAVideoBuf.NbBitsPoint DIV 8)]:= BYTE(GColor);
           2 : MemW[SegA000:Dest-(GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+1]:= WORD(GColor);
           3..4 : MemL[SegA000:Dest-(GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+3]:= GColor;
      END;
 END;*)

 PROCEDURE PutPixel;
 VAR Offset, Bloc : WORD;
     I            : BYTE;
     Masque       : DWORD;
 BEGIN
      IF (X > GetMaxX) OR (Y > GetMaxY) OR (X < 0) OR (Y < 0) THEN Exit;

      Cp.X:= X; Cp.Y:= Y;

      Bloc:= ((Y*(GrPlusVGAVideoBuf.NbBitsPoint DIV 8) * (GetMaxX+1)) + (X*GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+1) DIV
        (GrPlusVGAVideoBuf.Granularity*LongInt(1024));

      IF Bloc <> CurWindow THEN BEGIN
         CurWindow:= Bloc;
         SetWindowAccess(Bloc);
      END;

      Offset:= Y*(GrPlusVGAVideoBuf.NbBitsPoint DIV 8) * (GetMaxX+1) + (X*GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+1;
      Offset:= Offset-(Bloc*(GrPlusVGAVideoBuf.Granularity*LongInt(1024)));

      IF GrPlusVGAVideoBuf.NbBitsPoint = 8 THEN Mem[SegA000:Offset]:= BYTE(GColor);

      CASE GrPlusVGAVideoBuf.NbBitsPoint OF
           15..16 : MemW[SegA000:Offset-(GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+1]:= WORD(GColor);
           32     : BEGIN
                  Mem[SegA000:Offset-(GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+3]:= BYTE(GColor);
                  GColor:= GColor SHR 8;
                  IF Offset+1 > $FFFF THEN BEGIN
                     Offset:= 0; Bloc:= Bloc+1; SetWindowAccess(Bloc);
                  END ELSE Offset:= Offset+1;

                  Mem[SegA000:Offset-(GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+3]:= BYTE(GColor);
                  GColor:= GColor SHR 8;
                  IF Offset+1 > $FFFF THEN BEGIN
                     Offset:= 0; Bloc:= Bloc+1; SetWindowAccess(Bloc);
                  END ELSE Offset:= Offset+1;

                  Mem[SegA000:Offset-(GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+3]:= BYTE(GColor);
                    END;

      END;
 END;

 FUNCTION GetPixel;
 VAR Orig, Dest, NbBloc : LongInt;
 BEGIN
      IF (X > GetMaxX) OR (Y > GetMaxY) OR (X < 0) OR (Y < 0) THEN Exit;
      NbBloc:= ((Y*(GrPlusVGAVideoBuf.NbBitsPoint DIV 8) * (GetMaxX+1))+(X*GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+1) DIV
        (GrPlusVGAVideoBuf.Granularity*LongInt(1024));
      IF NbBloc <> CurWindow THEN BEGIN
         CurWindow:= NbBloc;
         SetWindowAccess(NbBloc);
      END;
      Orig:= Y*(GrPlusVGAVideoBuf.NbBitsPoint DIV 8) * (GetMaxX+1)+(X*GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+1;
      Dest:= Orig-((NbBloc)*(GrPlusVGAVideoBuf.Granularity*LongInt(1024)));


      CASE (GrPlusVGAVideoBuf.NbBitsPoint DIV 8) OF
           1 : GetPixel:= Mem[SegA000:Dest-(GrPlusVGAVideoBuf.NbBitsPoint DIV 8)];
           2 : GetPixel:= MemW[SegA000:Dest-(GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+1];
           3..4 : GetPixel:= MemL[SegA000:Dest-(GrPlusVGAVideoBuf.NbBitsPoint DIV 8)+3];
      END;
 END;

 PROCEDURE Line(X1,Y1,X2,Y2 : INTEGER; GColor : LongInt);
 { Auteur : Michael Tischer, LA BIBLE PC 1997 6me EDITION}

 VAR d, dx, dy,
     aincr, bincr,
     xincr, yincr,
     x, y,I : integer;

 {-- Procdure accessoire pour changer deux variables entires --------}

 PROCEDURE SwapInt(VAR i1, i2 : INTEGER);
 VAR dummy : integer;

 BEGIN
      dummy:= i2;
      i2   := i1;
      i1   := dummy;
 END;

 {-- Procdure principale ----------------------------------------------}

 BEGIN
      I:= 1;
      Cp.X:= X2; Cp.Y:= Y2;
      IF (ABS(X2-X1) < ABS(Y2-Y1)) THEN BEGIN  { Sens : par l'axe des X ou des Y }
         IF (Y1 > Y2) THEN BEGIN               { Y1 suprieur  Y2 ? }
           SwapInt(X1, X2);                    { Oui, change X1 et X2, }
           SwapInt(Y1, Y2);                    { Y1 et Y2 }
         END;

         IF (X2 > X1) THEN XIncr:= 1 ELSE XIncr:= -1;  { Fixe le pas horizontal }
         DY:= Y2 - Y1;
         DX:= ABS(X2-X1);
         D := 2 * DX - DY;
         AIncr:= 2 * (DX - DY);
         BIncr:= 2 * DX;
         X:= X1;
         Y:= Y1;
         IF LineStyle[I] = '1' THEN PutPixel(X, Y, GColor); { Dessine le premier point }
         I:= I+1;
         FOR Y:= Y1+1 TO Y2 DO BEGIN            { Parcourt l'axe des Y }
             IF (D >= 0) THEN BEGIN
               Inc(X, XIncr);
               Inc(D, AIncr);
             END ELSE Inc(D, BIncr);
           IF LineStyle[I] = '1' THEN PutPixel(X, Y, GColor);
           I:= I+1;
           IF I>Length(LineStyle) THEN I:= 1;
         END;
      END ELSE BEGIN                           { par l'axe des X }
         IF (X1 > X2) THEN BEGIN               { X1 plus grand que X2 ? }
           SwapInt(X1, X2);                    { Oui, change X1 et X2 }
           SwapInt(Y1, Y2);                    { Y1 et Y2 }
         END;
         IF (Y2 > Y1) THEN YIncr:= 1 ELSE YIncr:= -1;   { Fixe le pas vertical }
         DX:= X2 - X1;
         DY:= ABS(Y2-Y1);
         D := 2 * DY - DX;
         AIncr:= 2 * (DY - DX);
         BIncr:= 2 * DY;
         X:= X1;
         Y:= Y1;
         IF LineStyle[I] = '1' THEN PutPixel(X, Y, GColor);             { Dessine le premier point }
         I:= I+1;
         FOR X:= X1+1 TO X2 DO BEGIN            { Parcourt l'axe des X }
           IF (D >= 0) THEN BEGIN
               Inc(Y, YIncr);
               Inc(D, AIncr);
           END ELSE Inc(D, BIncr);
           IF LineStyle[I] = '1' THEN PutPixel(X, Y, GColor);
           I:= I+1;
           IF I>Length(LineStyle) THEN I:= 1;
        END;
      END;
 END;

 PROCEDURE LineTo;
 BEGIN
      Line(Cp.X,Cp.Y,X,Y, GColor);
      Cp.X:= X; Cp.Y:= Y;
 END;

 PROCEDURE MoveTo;
 BEGIN
      CP.X:= X; CP.Y:= Y;
 END;

 PROCEDURE GetXYCoords(VAR X,Y : INTEGER; Z : INTEGER); {Calcule X et Y en tenant
                                                  compte de la profondeur}
 VAR X_,Y_ : INTEGER;
 BEGIN
      IF Z > PointDeFuite.Z THEN Z:= PointDeFuite.Z;

      IF X < PointDeFuite.X THEN X_:= Round(X+(( (PointDeFuite.X-X)/PointDeFuite.Z)*Z));
      IF X >= PointDeFuite.X THEN X_:= Round(X-(( (X-PointDeFuite.X)/PointDeFuite.Z)*Z));

      IF Y < PointDeFuite.Y THEN Y_:= Round(Y+(( (PointDeFuite.Y-Y)/PointDeFuite.Z)*Z));
      IF Y >= PointDeFuite.Y THEN Y_:= Round(Y-(( (Y-PointDeFuite.Y)/PointDeFuite.Z)*Z));

      X:= X_; Y:= Y_;
 END;

 PROCEDURE PutPixel3D(X,Y,Z : WORD; Color : DWORD);
 VAR X_,Y_ : INTEGER;
 BEGIN
      X_:= X; Y_:= Y;
      GetXYCoords(X_,Y_,Z);

      PutPixel(X_,Y_, Color);

      Cp.X:= X_; Cp.Y:= Y_; Cp.Z:= Z;
 END;

 PROCEDURE Line3D(X1,Y1,Z1, X2,Y2,Z2 : WORD; Color : DWORD);
 VAR X1_,Y1_,Z1_, X2_,Y2_,Z2_ : INTEGER;
 BEGIN
      X1_:= X1; Y1_:= Y1; Z1_:= Z1;
      X2_:= X2; Y2_:= Y2; Z2_:= Z2;

      GetXYCoords(X1_,Y1_,Z1_); GetXYCoords(X2_,Y2_,Z2_);

      Line(X1_,Y1_,X2_,Y2_, Color);

      Cp.X:= X2; Cp.Y:= Y2; Cp.Z:= Z2;
 END;

 PROCEDURE LineTo3D(X,Y,Z : WORD; Color : DWORD);
 BEGIN
      Line3D(Cp.X,Cp.Y,Cp.Z, X,Y,Z, Color);
 END;

 PROCEDURE Box;
 VAR I, J : WORD;
 BEGIN
      Line(X1,Y1,X2,Y1,GColor);
      LineTo(X2,Y2, GColor);
      LineTo(X1,Y2, GColor);
      LineTo(X1,Y1, GColor);
      IF Fill = Full THEN BEGIN
         FOR I:= Y1 TO Y2 DO Line(X1,I,X2,I, GColor);
      END;
 END;

 PROCEDURE GSetColor;
 VAR RGB  : ARRAY [0..2] OF BYTE;
     Regs : Registers;
 BEGIN
      RGB[0]:= Red; RGB[1]:= Green; RGB[2]:= Blue;
      Regs.AX:= $1012;
      Regs.BX:= ColorNum;
      Regs.CX:= 1;
      Regs.ES:= Seg(RGB);
      Regs.DX:= Ofs(RGB);
      Intr($10, Regs);
 END;

 PROCEDURE GGetColor;
 VAR Regs : Registers;
 BEGIN
      Regs.AX:= $1015;
      Regs.BX:= ColorNum;
      Intr($10, Regs);
      Red:= Regs.DH; Green:= Regs.CH; Blue:= Regs.CL;
 END;

 PROCEDURE Circle;
 VAR I, Delta, C : LongInt;
     S1,S2       : REAL;
     LX,LY1,LY2  : WORD;
 BEGIN
      LX:= X-R; LY1:= Y; LY2:= Y;
      FOR I:= X-R TO X+R DO BEGIN
          C:= (I-X)*(I-X)-(R*R)+(Y*Y);
          Delta:= (4*Y*Y)-4*C;
          IF Delta >= 0 THEN BEGIN
             S1:= ((2*Y)-Sqrt(Delta)) / 2;
             S2:= ((2*Y)+Sqrt(Delta)) / 2;
             PutPixel(I,Trunc(S1),GColor);
             PutPixel(I,Trunc(S2),GColor);
             Line(LX,LY1,I,Trunc(S1),GColor);
             Line(LX,LY2,I,Trunc(S2),GColor);
             LX:= I;
             LY1:= Trunc(S1); LY2:= Trunc(S2);
          END;
      END;
 END;

 PROCEDURE Ellipse;
 VAR I, Delta, C : LongInt;
     S1,S2       : REAL;
     LX1,LX2,LY1,LY2  : WORD;
     Rapport     : REAL;
     Hauteur     : REAL;
 BEGIN
      IF XR <= 0 THEN Exit;
      IF YR <= 0 THEN Exit;

      LX1:= X-XR; LX2:= X-XR; LY1:= Y; LY2:= Y;

      IF XR >= YR THEN BEGIN
         Rapport:= XR/YR;

         FOR I:= X-XR TO X+XR DO BEGIN
             C:= (I-X)*(I-X)-(XR*XR)+(Y*Y);
             Delta:= (4*Y*Y)-4*C;
             IF Delta >= 0 THEN BEGIN
                S1:= ((2*Y)-Sqrt(Delta)) / 2;
                S2:= ((2*Y)+Sqrt(Delta)) / 2;

                S1:= S1/Rapport; S2:= S2/Rapport;
                IF Delta = 0 THEN Hauteur:= Y-S1;

                PutPixel(I,Trunc(S1)+Round(Hauteur),GColor);
                PutPixel(I,Trunc(S2)+Round(Hauteur),GColor);
                Line(LX1,LY1,I,Trunc(S1)+Round(Hauteur),GColor);
                Line(LX1,LY2,I,Trunc(S2)+Round(Hauteur),GColor);
                LX1:= I;
             END;
             LY1:= Trunc(S1)+Round(Hauteur); LY2:= Trunc(S2)+Round(Hauteur);
          END;
      END;

      LX1:= X; LX2:= X; LY1:= Y; LY2:= Y;

      IF YR > XR THEN BEGIN
         Rapport:= YR/XR;

         FOR I:= Y-YR TO Y+YR DO BEGIN
             C:= (I-Y)*(I-Y)-(YR*YR)+(X*X);
             Delta:= (4*X*X)-4*C;
             IF Delta >= 0 THEN BEGIN
                S1:= ((2*X)-Sqrt(Delta)) / 2;
                S2:= ((2*X)+Sqrt(Delta)) / 2;

                S1:= S1/Rapport; S2:= S2/Rapport;
                IF Delta = 0 THEN Hauteur:= X-S1;

                PutPixel(Trunc(S1)+Round(Hauteur),I,GColor);
                PutPixel(Trunc(S2)+Round(Hauteur),I,GColor);
                Line(LX1,I,Trunc(S1)+Round(Hauteur),I,GColor);
                Line(LX2,I,Trunc(S2)+Round(Hauteur),I,GColor);
                LY1:= I;
             END;
             LX1:= Trunc(S1)+Round(Hauteur); LX2:= Trunc(S2)+Round(Hauteur);
          END;
      END;
 END;

 FUNCTION GetMaxX;
 BEGIN
      GetMaxX:= GScreenSize.X;
 END;

 FUNCTION GetMaxY;
 BEGIN
      GetMaxY:= GScreenSize.Y;
 END;

 FUNCTION GetCharWidth;
 BEGIN
      GetCharWidth:= FontHeader.Width;
 END;

 FUNCTION GetCharHeight;
 BEGIN
      GetCharHeight:= FontHeader.Height;
 END;

 FUNCTION GetMaxColor;
 BEGIN
      GetMaxColor:= Puissance(2,GrPlusVGAVideoBuf.NbBitsPoint)-1;
 END;

 PROCEDURE GetWindow;
 BEGIN
      CurWindowPos:= Rect;
 END;

 FUNCTION GetWriteMode;
 BEGIN
      GetWriteMode:= WriteMode;
 END;

 PROCEDURE UnLoadFont;
 BEGIN
      SetFilePos(FontHandle, SizeOf(FontHeader)+1+FontSignature);
      FreeMem(FontBuf, GetFileSize(FontHandle)-(GetFilePos(FontHandle)+1));
      CloseFile(FontHandle);
      IsLoaded:= FALSE;
 END;

 PROCEDURE LoadFont;
 BEGIN
      IF IsLoaded THEN UnLoadFont;
      FontHandle:= OpenFile(Name);
      IF IsThereError THEN BEGIN
         IsLoaded:= FALSE;
         Exit;
      END;
      SetFilePos(FontHandle, FontSignature);
      ReadFile(FontHandle, FontHeader, SizeOf(FontHeader));
      SetFilePos(FontHandle, SizeOf(FontHeader)+1+FontSignature);
      IF GetFileSize(FontHandle)-(GetFilePos(FontHandle)+1) > 65535 THEN BEGIN
         GetMem(FontBuf, 65535);
         ReadFile(FontHandle, FontBuf^, 65535);
      END ELSE BEGIN
          GetMem(FontBuf, GetFileSize(FontHandle)-(GetFilePos(FontHandle)+1));
          ReadFile(FontHandle, FontBuf^, GetFileSize(FontHandle)-(GetFilePos(FontHandle)+1));
      END;
      IsLoaded:= TRUE;
 END;

 PROCEDURE Window(X11,Y11,X22,Y22 : WORD);
 BEGIN
      WITH Rect DO BEGIN
           X1:= X11; X2:= X22; Y1:= Y11; Y2:= Y22;
      END;
 END;

 PROCEDURE SetWriteMode;
 BEGIN
      WriteMode:= WM;
 END;

 PROCEDURE GWrite;
 VAR Col,Li : WORD;
     Scr    : ^TScr;
     I,J,K  : BYTE;

 PROCEDURE ReadChar;
 VAR I1 : WORD;
 BEGIN
      FOR I1:= 1 TO GetCharWidth*GetCharHeight DO
        Scr^[I1-1]:= FontBuf^[(LongInt(S[K])*GetCharWidth*GetCharHeight)+I1];
 END;

 BEGIN
      CASE WriteMode OF
           VirtualScreen : BEGIN
                      Col:= (X*GetCharWidth)+Rect.X1; Li:= (Y*GetCharHeight)+Rect.Y1;
           END;
           RealScreen    : BEGIN
                      Col:= X+Rect.X1; Li:= Y+Rect.Y1;
           END;
      END;

      IF (Col > Rect.X2) OR (Li > Rect.Y2) OR (Col < Rect.X1) OR (Li < Rect.Y1) THEN Exit;

      New(Scr);
      FOR K:= 1 TO Length(S) DO BEGIN
          ReadChar;
          Scr^[(GetCharHeight-1)*GetCharWidth+GetCharWidth]:= Scr^[0];
            FOR I:= 1 TO GetCharWidth DO FOR J:= 1 TO GetCharHeight DO
             IF Scr^[(J-1)*GetCharWidth+I] = 1 THEN PutPixel(I+Col-1,J+Li-1,TC)
             ELSE IF TB = 255 THEN PutPixel(I+Col-1,J+Li-1,GetPixel(I+Col-1,J+Li-1)) ELSE PutPixel(I+Col-1,J+Li-1,TB);
            Col:= Col+GetCharWidth;
            IF (Col > Rect.X2) OR (Li > Rect.Y2) THEN BEGIN
               {Dispose(Scr);}
               Break;
            END;
      END;
      Dispose(Scr);
 END;

 PROCEDURE GColor;
 BEGIN
      TC:= X; TB:= Y;
 END;

 PROCEDURE GCenter;
 BEGIN
      IF WriteMode = RealScreen THEN
      GWrite(S, (GetMaxX DIV 2) - ((Length(S)*GetCharWidth) DIV 2), Ligne) ELSE
      GWrite(S, ((GetMaxX DIV GetCharWidth) DIV 2) - (Length(S) DIV 2), Ligne);
 END;

 PROCEDURE GMkSpace;
 VAR I : WORD;
 BEGIN
      FOR I:= Y1 TO Y2 DO GWrite(' ', I, Ligne);
 END;

 PROCEDURE GWFromTo;
 VAR I : WORD;
 BEGIN
      FOR I:= Col1 TO Col2 DO GWrite(Ch, I,Ligne);
 END;

 PROCEDURE GDrawBox;
 { DESSINE UNE BOITE SUR L'ECRAN AVEC/SANS OMBRE }
 VAR I, J : BYTE;
 BEGIN
      GColor(TxtColor,TxtGround);
      CASE ST OF
           Single : BEGIN
                  GWrite(#218, X1,Y1);
                  GWrite(#191, X2,Y1);
                  GWrite(#217, X2,Y2);
                  GWrite(#192, X1,Y2);
           END;
           UserDefinedBorder : BEGIN
                  GWrite(GUserBorder[0], X1,Y1);
                  GWrite(GUserBorder[2], X2,Y1);
                  GWrite(GUserBorder[4], X2,Y2);
                  GWrite(GUserBorder[6], X1,Y2);
           END;
           Double : BEGIN
                  GWrite(#201, X1,Y1);
                  GWrite(#187, X2,Y1);
                  GWrite(#188, X2,Y2);
                  GWrite(#200, X1,Y2);
           END;
           Solid  : BEGIN
                  GWrite(#219, X1,Y1);
                  GWrite(#219, X1,Y2);
                  GWrite(#219, X2,Y1);
                  GWrite(#219, X2,Y2);
           END;
           HDouble  : BEGIN
                  GWrite(#213, X1,Y1);
                  GWrite(#184, X1,Y2);
                  GWrite(#212, X2,Y1);
                  GWrite(#190, X2,Y2);
           END;
           VDouble  : BEGIN
                  GWrite(#214, X1,Y1);
                  GWrite(#183, X1,Y2);
                  GWrite(#211, X2,Y1);
                  GWrite(#189, X2,Y2);
           END;
           NoBorder : BEGIN
                  GWrite(' ', X1,Y1);
                  GWrite(' ', X1,Y2);
                  GWrite(' ', X2,Y1);
                  GWrite(' ', X2,Y2);
           END;
      END;

      FOR I:= Y1+1 TO Y2-1 DO
          CASE ST OF
               Single : BEGIN
                      GWrite(#179, X1,I);
                      GWrite(#179, X2,I);
               END;
               UserDefinedBorder : BEGIN
                      GWrite(GUserBorder[7], X1,I);
                      GWrite(GUserBorder[3], X2,I);
               END;
               VDouble: BEGIN
                      GWrite(#196, X1,I);
                      GWrite(#196, X2,I);
               END;
               Double : BEGIN
                      GWrite(#186, X1,I);
                      GWrite(#186, X2,I);
               END;
               HDouble: BEGIN
                      GWrite(#205, X1,I);
                      GWrite(#205, X2,I);
               END;
               Solid  : BEGIN
                      GWrite(#223, X1,I);
                      GWrite(#220, X2,I);
               END;
               NoBorder : BEGIN
                      GWrite(' ', X1,I);
                      GWrite(' ', X2,I);
               END;
      END;

      FOR I:= X1+1 TO X2-1 DO
          CASE ST OF
               Single : BEGIN
                      GWrite(#196, I,Y1);
                      GWrite(#196, I,Y2);
               END;
               UserDefinedBorder : BEGIN
                      GWrite(GUserBorder[1], I,Y1);
                      GWrite(GUserBorder[5], I,Y2);
               END;
               HDouble: BEGIN
                      GWrite(#179, I,Y1);
                      GWrite(#179, I,Y2);
               END;
               Double : BEGIN
                      GWrite(#205, I,Y1);
                      GWrite(#205, I,Y2);
               END;
               VDouble: BEGIN
                      GWrite(#186, I,Y1);
                      GWrite(#186, I,Y2);
               END;
               Solid  : BEGIN
                      GWrite(#221, I,Y1);
                      GWrite(#222, I,Y2);
               END;
               NoBorder : BEGIN
                      GWrite(' ', I,Y1);
                      GWrite(' ', I,Y2);
               END;
      END;

      FOR I:= X1+1 TO X2-1 DO FOR J:= Y1+1 TO Y2-1 DO GWrite(' ', I,J);
 END;

 PROCEDURE Bouton;
 BEGIN
      CASE BoutonType OF
           Out : BEGIN
               Line(X1,Y1,X2,Y1, C);
               Line(X1,Y2,X2,Y2, 0000);
               Line(X1,Y1,X1,Y2, C);
               Line(X2,Y1,X2,Y2, 0000);
           END;
           Inn : BEGIN
               Line(X1,Y1,X2,Y1, 0000);
               Line(X1,Y2,X2,Y2, C);
               Line(X1,Y1,X1,Y2, 0000);
               Line(X2,Y1,X2,Y2, C);
           END;
      END;

      IF FillType = Full THEN Box(X1+1,Y1+1,X2-1,Y2-1, C DIV 2, Full);
 END;

 PROCEDURE DLine;
 BEGIN
      IF (X2-X1) >= (Y2-Y1) THEN BEGIN
         Line(X1,Y1,X2,Y2, 0);
         Line(X1,Y1+1,X2,Y2+1, C);
      END ELSE BEGIN
         Line(X1,Y1,X2,Y2, 0);
         Line(X1+1,Y1,X2+1,Y2, C);
      END;
 END;

 PROCEDURE GCenterXY;
 VAR Col : WORD;
 BEGIN
      IF Length(Chaine) > Col2-Col1+1 THEN Exit;
      Col:= ((Col2+Col1+2)-Length(Chaine)) DIV 2;
      GWrite(Chaine, Col,Ligne);
 END;

 PROCEDURE GLeftText;
 VAR CurWord : STRING;
     Ligne, Col, I, Pos : WORD;

 BEGIN
      IF Text[Length(Text)] <> ' ' THEN Text:= Text+' ';
      Ligne:= X1; Col:= Y1;
      Pos:= 1;
      WHILE Pos <= Length(Text) DO BEGIN
            I:= Pos;
            WHILE Text[I] <> ' ' DO
            I:= I+1;
            CurWord:= Copy(Text,Pos,I-Pos);
            IF Col+Length(CurWord) <= Y2 THEN GWrite(CurWord, Col,Ligne) ELSE BEGIN
               Ligne:= Ligne + 1;
               IF Ligne > X2 THEN Break;
               Col:= Y1;
               GWrite(CurWord, Col,Ligne);
            END;
            Pos:= Pos+Length(CurWord)+1;
            Col:= Col+Length(CurWord)+1;
      END;
 END;

 PROCEDURE GCenterText;
 VAR CurWord, Phrase : STRING;
     Ligne, Col, I, Pos : WORD;

 BEGIN
      IF Text[Length(Text)] <> ' ' THEN Text:= Text+' ';
      Ligne:= X1; Col:= Y1;
      Pos:= 1; Phrase:= '';
      WHILE Pos <= Length(Text) DO BEGIN
            I:= Pos;
            WHILE Text[I] <> ' ' DO
            I:= I+1;
            CurWord:= Copy(Text,Pos,I-Pos);
            IF Col+Length(CurWord) <= Y2 THEN Phrase:= Phrase+' '+CurWord ELSE BEGIN
               GCenterXY(Phrase, Y1,Y2, Ligne);
               Ligne:= Ligne + 1;
               IF Ligne > X2 THEN Break;
               Col:= Y1;
               Phrase:= CurWord;
            END;
            Pos:= Pos+Length(CurWord)+1;
            Col:= Col+Length(CurWord)+1;
      END;
      IF Pos >= Length(Text) THEN TCenterXY(Phrase, Ligne,Y1,Y2);
 END;

 BEGIN
      Cp.X:= 0; Cp.Y:= 0; Cp.Z:= 0;

      LineStyle:= '1111';
      IsLoaded:= FALSE;
      InGraph:= FALSE;
      GColor(65535,0);
      SetWriteMode(RealScreen);
      GUserBorder[0]:= '';
      GUserBorder[1]:= '';
      GUserBorder[2]:= '';
      GUserBorder[3]:= '';
      GUserBorder[4]:= '';
      GUserBorder[5]:= '';
      GUserBorder[6]:= '';
      GUserBorder[7]:= '';
 END.