 {$A+,B+,D+,E-,F+,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T+,V-,X+,Y+}
 {$M 32768,0,655360}
 PROGRAM Mandelbrot;
 {Programme original de Zavie, Zavie@NetCourrier.Com}

 USES CrtPlus, GrPlus, Keyboard, Dos;

 CONST MinX = -2;
       MaxX = 1;
       MinY = -1;
       MaxY = 1;

 VAR Dx, Dy : REAL;
     X, Y   : WORD;
     R      : SearchRec;

 PROCEDURE Presentation;
 BEGIN
      IF GetVideoMode <> 3 THEN SetTextMode(3);
      TColor(7,0); Clear; SetCursorPos(24,1); HideCursor;
      TDrawBox(1,1,4,80, 7,0, Off, Single);
      TCenter('DEMONSTRATION GRAPHIQUE -- FRACTALES -- ENSEMBLE DE MANDELBROT',2);
      TCenter('Sad LANKRI.',3);
      Delay(1000);
 END;

 FUNCTION CalcPixel(A,iB : REAL) : INTEGER;
 CONST MaxIteration = 64;
 VAR   Iteration     : INTEGER;
       Z, a_, b, a2  : REAL;

 BEGIN
      a_:=0; b:=0;
      Iteration:=0;
      REPEAT
            a2:= a_;
            a_:= (a_*a_)-(b*b)+A;
            b:= 2*(a2*b)+iB;
            Iteration:= Iteration+1;
            z:= (a_*a_)+(b*b);
      UNTIL (z > 4) OR (Iteration > Maxiteration);
      CalcPixel:= GetColorIndex(Iteration,Iteration,0,0);
 END;

 BEGIN
      Presentation;

      IF NOT IsVESA THEN BEGIN
         TColor(7,0);
         TWrite('Ce programme requiert une carte graphique VESA (Super VGA)',6,1);
         SetCursorSize(15,16); SetCursorPos(8,1); Halt(255);
      END;

      IF GetModeNum(640,480,16) = 0 THEN BEGIN
         TColor(7,0);
         TWrite('Ce programme requiert un affichage 800x600 16 bits',6,1);
         SetCursorSize(15,16); SetCursorPos(8,1); Halt(255);
      END;

      FindFirst('text8x16.grf', Anyfile, R);
      WHILE DosError = 0 DO BEGIN
            IF R.Name = 'TEXT8X16.GRF' THEN Break;
            FindNext(R);
      END;

      IF DosError <> 0 THEN BEGIN
         TColor(7,0);
         TWrite('TEXT8X16.GRF : Le fichier est introuvable ou inaccessible.',6,1);
         SetCursorSize(15,16); SetCursorPos(8,1); Halt(255);
      END;

      SetVESAMode(GetModeNum(800,600,16)); LoadFont('text8x16.grf');
      GColor(65535,0);
      SetWriteMode(VirtualScreen);
      GWrite('Dmonstration de gomtrie -- Fractales -- Ensemble de Mandelbrot',0,0);
      GWrite('17/10/2001, Sad LANKRI.',0,1);
      GWrite('lankri_said@yahoo.fr',0,2);
      GWrite('Programme original de Zavie, Zavie@NetCourrier.Com',0,3);

      Dx:= (MaxX-MinX)/GetMaxX;
      Dy:= (MaxY-MinY)/(GetMaxY-64);

      FOR Y:= 64 TO GetMaxY DO BEGIN
          FOR X:= 0 TO GetMaxX DO BEGIN
              PutPixel(X,Y, CalcPixel(MinX+(X*Dx),MinY+((Y-64)*Dy)));
              IF Port[$60] = 1 THEN Break;
          END;
          IF Port[$60] = 1 THEN Break;
      END;

      ClearKbdBuf;
      WaitForKey; UnLoadFont;

      SetTextMode(3); SetCursorSize(15,16); SetCursorPos(1,1); Halt(0);
 END.