{$A+,B+,D+,E-,F+,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T+,V-,X+,Y+}
{$M 32768,0,655360}

 PROGRAM Tamis_de_Sierpinski;
 USES CrtPlus, Dos, GrPlus;

 VAR R : SearchRec;
     A,B,C : TPoint;

 PROCEDURE DrawTriangle(A,B,C : TPoint; Niveau : BYTE);
 VAR M1,M2,M3 : TPoint;
 BEGIN
      IF Niveau > 10 THEN Exit;

      M1.X:= (A.X+B.X) DIV 2; M1.Y:= (A.Y+B.Y) DIV 2;
      M2.X:= (A.X+C.X) DIV 2; M2.Y:= (A.Y+C.Y) DIV 2;
      M3.X:= (C.X+B.X) DIV 2; M3.Y:= (C.Y+B.Y) DIV 2;

      Line(M1.X,M1.Y,M2.X,M2.Y, 65535);
      LineTo(M3.X,M3.Y, 65535);
      LineTo(M1.X,M1.Y, 65535);

      DrawTriangle(A,M1,M2, Niveau+1);
      DrawTriangle(B,M1,M3, Niveau+1);
      DrawTriangle(C,M2,M3, Niveau+1);
 END;

 PROCEDURE Presentation;
 BEGIN
      IF GetVideoMode <> 3 THEN SetTextMode(3);
      TColor(7,0); Clear; SetCursorPos(24,1); HideCursor;
      TDrawBox(1,1,4,80, 7,0, Off, Single);
      TCenter('DEMONSTRATION GRAPHIQUE -- FRACTALES -- Tamis de Sierpinski',2);
      TCenter('Sad LANKRI.',3);
      Delay(1000);
 END;

 BEGIN
      Presentation;

      IF NOT IsVESA THEN BEGIN
         TColor(7,0);
         TWrite('Ce programme requiert une carte graphique VESA (Super VGA)',6,1);
         SetCursorSize(15,16); SetCursorPos(8,1); Halt(255);
      END;

      IF GetModeNum(800,600,16) = 0 THEN BEGIN
         TColor(7,0);
         TWrite('Ce programme requiert un affichage 800x600 16 bits',6,1);
         SetCursorSize(15,16); SetCursorPos(8,1); Halt(255);
      END;

      FindFirst('text8x16.grf', Anyfile, R);
      WHILE DosError = 0 DO BEGIN
            IF R.Name = 'TEXT8X16.GRF' THEN Break;
            FindNext(R);
      END;

      IF DosError <> 0 THEN BEGIN
         TColor(7,0);
         TWrite('TEXT8X16.GRF : Le fichier est introuvable ou inaccessible.',6,1);
         SetCursorSize(15,16); SetCursorPos(8,1); Halt(255);
      END;

      SetVESAMode(GetModeNum(800,600,16)); LoadFont('text8x16.grf');
      GColor(65535,0);
      SetWriteMode(VirtualScreen);
      GWrite('Dmonstration de gomtrie -- Fractales -- Tamis de Sierpinski',0,0);
      GWrite('27/09/2001, Sad LANKRI',0,1);
      GWrite('lankri_said@yahoo.fr',0,2);

      A.X:= GetMaxX DIV 2; A.Y:= 3*16;
      B.X:= 0; B.Y:= GetMaxY;
      C.X:= GetMaxX; C.Y:= GetMaxY;

      Line(A.X,A.Y,B.X,B.Y, 65535);
      LineTo(C.X,C.Y, 65535);
      LineTo(A.X,A.Y, 65535);

      DrawTriangle(A,B,C, 0);

      WaitForKey;

      UnLoadFont;
      SetTextMode(3); SetCursorSize(15,16); SetCursorPos(1,1); Halt(0);
 END.