{$A+,B+,D+,E-,F+,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T+,V-,X+,Y+}
{$M 32768,0,655360}
 PROGRAM Flocon_de_Von_Koch;
 USES CrtPlus, Dos, GrPlus;

 TYPE TPoint = RECORD
      X,Y : INTEGER;
 END;

 VAR R : SearchRec;
     A,B,C : TPoint;
     Rapport : REAL;

 PROCEDURE DrawTriangle(A,C : TPoint; Niveau : BYTE);
 VAR A_,B_,C_ : TPoint;
 BEGIN
      {IF Sqr(A.X-C.X)+Sqr(A.Y-C.Y) < 100 THEN Exit;}

      IF Niveau > 10 THEN Exit;

      A_.X:= Round(A.X+Rapport*(C.X-A.X));
      A_.Y:= Round(A.Y+Rapport*(C.Y-A.Y));

      B_.X:= Round(C.X+Rapport*(A.X-C.X));
      B_.Y:= Round(C.Y+Rapport*(A.Y-C.Y));

      C_.X:= Round((B_.X-A_.X)*Cos(Pi/3) - (B_.Y-A_.Y)*Sin(Pi/3) + A_.X);
      C_.Y:= Round((B_.Y-A_.Y)*Cos(Pi/3) + (B_.X-A_.X)*Sin(Pi/3) + A_.Y);

      Line(A_.X,A_.Y,B_.X,B_.Y, 0);
      Line(A_.X,A_.Y,C_.X,C_.Y, 58922-((30 DIV 10)*Niveau));
      Line(B_.X,B_.Y,C_.X,C_.Y, 58922-((30 DIV 10)*Niveau));

      DrawTriangle(A_,C_, Niveau+1); {ne pas inverser l'ordre}
      DrawTriangle(C_,B_, Niveau+1);
      {DrawTriangle(B_,A_, Niveau+1);}
 END;

 PROCEDURE Presentation;
 BEGIN
      IF GetVideoMode <> 3 THEN SetTextMode(3);
      TColor(7,0); Clear; SetCursorPos(24,1); HideCursor;
      TDrawBox(1,1,4,80, 7,0, Off, Single);
      TCenter('DEMONSTRATION GRAPHIQUE -- FRACTALES -- Flocon de Von Koch',2);
      TCenter('Sad LANKRI.',3);
      Delay(1000);
 END;

 BEGIN
      Presentation;

      IF NOT IsVESA THEN BEGIN
         TColor(7,0);
         TWrite('Ce programme requiert une carte graphique VESA (Super VGA)',6,1);
         SetCursorSize(15,16); SetCursorPos(8,1); Halt(255);
      END;

      IF GetModeNum(800,600,16) = 0 THEN BEGIN
         TColor(7,0);
         TWrite('Ce programme requiert un affichage 800x600 16 bits',6,1);
         SetCursorSize(15,16); SetCursorPos(8,1); Halt(255);
      END;

      FindFirst('text8x16.grf', Anyfile, R);
      WHILE DosError = 0 DO BEGIN
            IF R.Name = 'TEXT8X16.GRF' THEN Break;
            FindNext(R);
      END;

      IF DosError <> 0 THEN BEGIN
         TColor(7,0);
         TWrite('TEXT8X16.GRF : Le fichier est introuvable ou inaccessible.',6,1);
         SetCursorSize(15,16); SetCursorPos(8,1); Halt(255);
      END;

      SetVESAMode(GetModeNum(800,600,16)); LoadFont('text8x16.grf');
      GColor(65535,0);
      SetWriteMode(VirtualScreen);
      GWrite('Dmonstration de gomtrie -- Fractales -- Flocon de Von Koch',0,0);
      GWrite('27/09/2001, Sad LANKRI',0,1);
      GWrite('lankri_said@yahoo.fr',0,2);

      A.X:= 200; A.Y:= 200;
      B.X:= 600; B.Y:= 200;
      C.X:= Round((B.X-A.X)*Cos(Pi/3) - (B.Y-A.Y)*Sin(Pi/3) + A.X);
      C.Y:= Round((B.Y-A.Y)*Cos(Pi/3) + (B.X-A.X)*Sin(Pi/3) + A.Y);

      Line(A.X,A.Y,B.X,B.Y, 65535);
      Line(B.X,B.Y,C.X,C.Y, 65535);
      Line(C.X,C.Y,A.X,A.Y, 65535);

      Rapport:= 1/5;

      DrawTriangle(C,B,0);
      DrawTriangle(A,C,0);
      DrawTriangle(B,A,0);

      WaitForKey;
 END.