{$A+,B+,D+,E-,F+,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T+,V-,X+,Y+}
{$M 32768,0,655360}
 PROGRAM Illusion_3D;

 { Dmonstration de l'illusion effet 3D d'un cube
   Sad LANKRI,
   Au point
   2001

   Note : La rotation de l'objet se fait par rapport  son point de gravit
   et non par rapport au point de fuite

   Si l'objet parat 'dform', ce n'est qu'une illusion d'optique
   Le barycentre peut ne pas paratre parfois superpos au centre de gravit
   de l'objet, ceci et d  ce que le barycentre est dessin en tenant compte
   de sa profondeur, donc un peu eloign.
 }

 USES CrtPlus, GrPlus, Keyboard, Dos, Convert;

 CONST MaxSommets = 20;

 TYPE T3DPoint = RECORD
      X,Y,Z : INTEGER;
 END;
      SommetTab = ARRAY[1..MaxSommets] OF T3DPoint;

 VAR Barycentre : T3DPoint;
     Objet        : SommetTab;
     NbSommets    : BYTE;
     AngleHoriz, AngleVert, AngleHoraire : REAL;

 PROCEDURE DrawObject(Color : DWORD); {Petit aperu}
 VAR I : BYTE;
 BEGIN
      FOR I:= 1 TO NbSommets-1 DO BEGIN
          Line3D(Objet[I].X,Objet[I].Y,Objet[I].Z,Objet[I+1].X,Objet[I+1].Y,Objet[I+1].Z, Color);
      END;
 END;

 PROCEDURE CalculBarycentre;
 BEGIN
      Barycentre.X:= Round( (Objet[1].X+Objet[2].X+Objet[3].X+Objet[4].X+
                     Objet[6].X+Objet[7].X+Objet[8].X+Objet[9].X) /8);
      Barycentre.Y:= Round( (Objet[1].Y+Objet[2].Y+Objet[3].Y+Objet[4].Y+
                     Objet[6].Y+Objet[7].Y+Objet[8].Y+Objet[9].Y) /8);
      Barycentre.Z:= Round( (Objet[1].Z+Objet[2].Z+Objet[3].Z+Objet[4].Z+
                     Objet[6].Z+Objet[7].Z+Objet[8].Z+Objet[9].X) /8);
 END;

 PROCEDURE MoveUp;
 VAR I : BYTE;
 BEGIN
      FOR I:= 1 TO NbSommets DO Objet[I].Y:= Objet[I].Y-10;
      CalculBarycentre;
 END;

 PROCEDURE MoveDown;
 VAR I : BYTE;
 BEGIN
      FOR I:= 1 TO NbSommets DO Objet[I].Y:= Objet[I].Y+10;
      CalculBarycentre;
 END;

 PROCEDURE MoveLeft;
 VAR I : BYTE;
 BEGIN
      FOR I:= 1 TO NbSommets DO Objet[I].X:= Objet[I].X-10;
      CalculBarycentre;
 END;

 PROCEDURE MoveRight;
 VAR I : BYTE;
 BEGIN
      FOR I:= 1 TO NbSommets DO Objet[I].X:= Objet[I].X+10;
      CalculBarycentre;
 END;

 PROCEDURE RotationHoraire;
 VAR I : BYTE;
     X,Y : WORD;
 BEGIN
      FOR I:= 1 TO NbSommets DO BEGIN
          X:= Round(Barycentre.X*(1-Cos(AngleHoraire))+Objet[I].X*Cos(AngleHoraire)
              -Objet[I].Y*Sin(AngleHoraire)+Barycentre.Y*Sin(AngleHoraire));
          Y:= Round(Barycentre.Y*(1-Cos(AngleHoraire))+Objet[I].Y*Cos(AngleHoraire)
              +Objet[I].X*Sin(AngleHoraire)-Barycentre.X*Sin(AngleHoraire));

          Objet[I].X:= X; Objet[I].Y:= Y;
      END;
 END;

 PROCEDURE RotationAntiHoraire;
 VAR I : BYTE;
     X,Y : WORD;
 BEGIN
      FOR I:= 1 TO NbSommets DO BEGIN
          X:= Round(Barycentre.X*(1-Cos(-AngleHoraire))+Objet[I].X*Cos(-AngleHoraire)
              -Objet[I].Y*Sin(-AngleHoraire)+Barycentre.Y*Sin(-AngleHoraire));
          Y:= Round(Barycentre.Y*(1-Cos(-AngleHoraire))+Objet[I].Y*Cos(-AngleHoraire)
              +Objet[I].X*Sin(-AngleHoraire)-Barycentre.X*Sin(-AngleHoraire));

          Objet[I].X:= X; Objet[I].Y:= Y;
      END;
 END;

 PROCEDURE RotateRight;
 VAR I : BYTE;
     X,Z : WORD;
 BEGIN
      FOR I:= 1 TO NbSommets DO BEGIN
          X:= Round(Barycentre.X*(1-Cos(AngleHoriz))+Objet[I].X*Cos(AngleHoriz)
              -Objet[I].Z*Sin(AngleHoriz)+Barycentre.Z*Sin(AngleHoriz));
          Z:= Round(Barycentre.Z*(1-Cos(AngleHoriz))+Objet[I].Z*Cos(AngleHoriz)
              +Objet[I].X*Sin(AngleHoriz)-Barycentre.X*Sin(AngleHoriz));

          Objet[I].X:= X; Objet[I].Z:= Z;
      END;
 END;

 PROCEDURE RotateLeft;
 VAR I : BYTE;
     X,Z : WORD;
 BEGIN
      FOR I:= 1 TO NbSommets DO BEGIN
          X:= Round(Barycentre.X*(1-Cos(-AngleHoriz))+Objet[I].X*Cos(-AngleHoriz)
              -Objet[I].Z*Sin(-AngleHoriz)+Barycentre.Z*Sin(-AngleHoriz));
          Z:= Round(Barycentre.Z*(1-Cos(-AngleHoriz))+Objet[I].Z*Cos(-AngleHoriz)
              +Objet[I].X*Sin(-AngleHoriz)-Barycentre.X*Sin(-AngleHoriz));

          Objet[I].X:= X; Objet[I].Z:= Z;
      END;
 END;

 PROCEDURE RotateDown;
 VAR I : BYTE;
     Y,Z : WORD;
 BEGIN
      FOR I:= 1 TO NbSommets DO BEGIN
          Y:= Round(Barycentre.Y*(1-Cos(AngleVert))+Objet[I].Y*Cos(AngleVert)
              -Objet[I].Z*Sin(AngleVert)+Barycentre.Z*Sin(AngleVert));
          Z:= Round(Barycentre.Z*(1-Cos(AngleVert))+Objet[I].Z*Cos(AngleVert)
              +Objet[I].Y*Sin(AngleVert)-Barycentre.Y*Sin(AngleVert));

          Objet[I].Y:= Y; Objet[I].Z:= Z;
      END;
 END;

 PROCEDURE RotateUp;
 VAR I : BYTE;
     Y,Z : WORD;
 BEGIN
      FOR I:= 1 TO NbSommets DO BEGIN
          Y:= Round(Barycentre.Y*(1-Cos(-AngleVert))+Objet[I].Y*Cos(-AngleVert)
              -Objet[I].Z*Sin(-AngleVert)+Barycentre.Z*Sin(-AngleVert));
          Z:= Round(Barycentre.Z*(1-Cos(-AngleVert))+Objet[I].Z*Cos(-AngleVert)
              +Objet[I].Y*Sin(-AngleVert)-Barycentre.Y*Sin(-AngleVert));

          Objet[I].Y:= Y; Objet[I].Z:= Z;
      END;
 END;

 PROCEDURE Presentation;
 BEGIN
      IF GetVideoMode <> 3 THEN SetTextMode(3);
      TColor(7,0); Clear; SetCursorPos(24,1); SetCursorSize(15,16);
      TDrawBox(1,1,4,80, 7,0, Off, Single);
      TCenter('DEMONSTRATION GRAPHIQUE -- EFFET ILLUSION 3D',2);
      TCenter('Sad LANKRI.',3);
      Delay(1000);
 END;

 VAR Key : KeyInfo;
     R   : SearchRec;
     X_,Y_ : INTEGER;
     NbFois,Count,Mouv : WORD;
     DemoMode : BOOLEAN;

 LABEL Reset;

 BEGIN
      Presentation;

      IF NOT IsVESA THEN BEGIN
         TColor(7,0);
         TWrite('Ce programme requiert une carte graphique VESA (Super VGA)',6,1);
         SetCursorSize(15,16); SetCursorPos(8,1); Halt(255);
      END;

      IF GetModeNum(800,600,16) = 0 THEN BEGIN
         TColor(7,0);
         TWrite('Ce programme requiert un affichage 800x600 16 bits',6,1);
         SetCursorSize(15,16); SetCursorPos(8,1); Halt(255);
      END;

      FindFirst('text8x16.grf', Anyfile, R);
      WHILE DosError = 0 DO BEGIN
            IF R.Name = 'TEXT8X16.GRF' THEN Break;
            FindNext(R);
      END;

      IF DosError <> 0 THEN BEGIN
         TColor(7,0);
         TWrite('TEXT8X16.GRF : Le fichier est introuvable ou inaccessible.',6,1);
         SetCursorSize(15,16); SetCursorPos(8,1); Halt(255);
      END;
      LoadFont('text8x16.grf');

      DemoMode:= FALSE;

 Reset :

      Randomize;

      SetVESAMode(GetModeNum(800,600,16));

      GColor(65535,00000);
      SetWriteMode(VirtualScreen);
      GWrite('Dmonstration de gomtrie -- Effet 3D -- Dsormais intgrs dans GrPlus',0,0);
      GWrite('12/08/2001, Sad LANKRI, said_lankri@Yahoo.fr',0,1);

      GColor(6584,00000);
      GWrite('Touches de direction pour dplacer objet',0,3);
      GWrite('SHIFT+Touches de direction dplacer point de fuite',0,4);
      GWrite('CTRL+Touches de direction pour rotation par rapport  l''horizontale/la verticale',0,5);
      GWrite('ALT+Touches droite/gauche rotation horaire/anti-horaire',0,6);
      GWrite('Si l''objet parat dform, ce n''est q''une illusion d''optique',0,7);

      GWrite('D mode dmo On/Off -- R reset -- blanc point de fuite, bleu barycentre',0,8);

      WITH PointDeFuite DO BEGIN
           X:= GetMaxX DIV 2; Y:= GetMaxY DIV 2; Z:= 1500;
           PutPixel(X,Y, 65535);
      END;

      NbSommets:= 17; AngleHoriz:= Pi/30; AngleVert:= Pi/30; AngleHoraire:= Pi/30;

      Objet[1].X:= 200; Objet[1].Y:= 200; Objet[1].Z:= 300;
      Objet[2].X:= 600; Objet[2].Y:= 200; Objet[2].Z:= 300;
      Objet[3].X:= 600; Objet[3].Y:= 300; Objet[3].Z:= 300;
      Objet[4].X:= 200; Objet[4].Y:= 300; Objet[4].Z:= 300;

      Objet[5]:= Objet[1];

      Objet[6]:= Objet[1]; Objet[6].Z:= 600;
      Objet[7]:= Objet[2]; Objet[7].Z:= 600;
      Objet[8]:= Objet[3]; Objet[8].Z:= 600;
      Objet[9]:= Objet[4]; Objet[9].Z:= 600;
      Objet[10]:= Objet[5]; Objet[10].Z:= 600;

      Objet[11]:= Objet[7];
      Objet[12]:= Objet[2];
      Objet[13]:= Objet[3];
      Objet[14]:= Objet[4];
      Objet[15]:= Objet[9];
      Objet[16]:= Objet[8];
      Objet[17]:= Objet[3];

      Key.Name:= ''; CalculBarycentre; Count:= 0; NbFois:= Random(10); Mouv:= Random(10);
      Port[$60]:= 0;
      GColor(6584,00000);
      CASE DemoMode OF
           TRUE  : GWrite('On',12,8);
           FALSE : GWrite('Off',15,8);
      END;
      GColor(29949,00000);
      CASE DemoMode OF
           TRUE  : GWrite('On',12,8);
           FALSE : GWrite('Off',15,8);
      END;
      WHILE Key.Name <> 'ESC' DO BEGIN
            CalculBarycentre;
            DrawObject(58922);
            WITH PointDeFuite DO BEGIN
                 Line(X-5,Y,X+5,Y, 65535);
                 Line(X,Y-5,X,Y+5, 65535);
            END;
            WITH Barycentre DO BEGIN
                 X_:= X; Y_:= Y;
                 GetXYCoords(X_,Y_, Z);
                 Line(X_-5,Y_,X_+5,Y_, 31);
                 Line(X_,Y_-5,X_,Y_+5, 31);
            END;

            IF DemoMode THEN Delay(Random(30)) ELSE GetKey(Key);

            DrawObject(0);
            WITH PointDeFuite DO BEGIN
                 Line(X-5,Y,X+5,Y, 00);
                 Line(X,Y-5,X,Y+5, 00);
            END;
            WITH Barycentre DO BEGIN
                 X_:= X; Y_:= Y;
                 GetXYCoords(X_,Y_, Z);
                 Line(X_-5,Y_,X_+5,Y_, 0000);
                 Line(X_,Y_-5,X_,Y_+5,0000);
            END;

            IF DemoMode = FALSE THEN BEGIN

            IF Key.Name = 'GRAY UP' THEN MoveUp;
            IF Key.Name = 'GRAY DOWN' THEN MoveDown;
            IF Key.Name = 'GRAY LEFT' THEN MoveLeft;
            IF Key.Name = 'GRAY RIGHT' THEN MoveRight;

            IF Key.Name = 'SHIFT+GRAY UP' THEN PointDeFuite.Y:= PointDeFuite.Y-10;
            IF Key.Name = 'SHIFT+GRAY DOWN' THEN PointDeFuite.Y:= PointDeFuite.Y+10;
            IF Key.Name = 'SHIFT+GRAY LEFT' THEN PointDeFuite.X:= PointDeFuite.X-10;
            IF Key.Name = 'SHIFT+GRAY RIGHT' THEN PointDeFuite.X:= PointDeFuite.X+10;

            IF Key.Name = 'ALT+RIGHT' THEN RotationHoraire;
            IF Key.Name = 'ALT+LEFT' THEN RotationAntiHoraire;
            IF Key.Name = 'ALT+UP' THEN PointDeFuite.Z:= PointDeFuite.Z-10;
            IF Key.Name = 'ALT+DOWN' THEN PointDeFuite.Z:= PointDeFuite.Z+10;

            IF Key.Name = 'CTRL+GRAY LEFT' THEN RotateLeft;
            IF Key.Name = 'CTRL+GRAY RIGHT' THEN RotateRight;
            IF Key.Name = 'CTRL+GRAY UP' THEN RotateUp;
            IF Key.Name = 'CTRL+GRAY DOWN' THEN RotateDown;

            END;

            IF DemoMode THEN BEGIN

            IF Count < NbFois THEN Count:= Count+1 ELSE BEGIN
               NbFois:= 5+Random(20);
               Count:= 0;
               Mouv:= Random(14);
            END;
            CASE Mouv OF
                 0 : RotationHoraire;
                 1 : RotationAntiHoraire;
                 2 : MoveUp;
                 3 : MoveDown;
                 4 : MoveLeft;
                 5 : MoveRight;
                 6 : RotateUp;
                 7 : RotateDown;
                 8 : RotateLeft;
                 9 : RotateRight;

                 10 : PointDeFuite.X:= PointDeFuite.X-10;
                 11 : PointDeFuite.X:= PointDeFuite.X+10;
                 12 : PointDeFuite.Y:= PointDeFuite.Y-10;
                 13 : PointDeFuite.Y:= PointDeFuite.Y+10;
                 14 : PointDeFuite.Z:= PointDeFuite.Z-10;
                 15 : PointDeFuite.Z:= PointDeFuite.Z+10;
            END;

            IF PointDeFuite.X < 2 THEN PointDeFuite.X:= 2;
            IF PointDeFuite.X > GetMaxX THEN PointDeFuite.X:= GetMaxX;
            IF PointDeFuite.Y < 16*7 THEN PointDeFuite.Y:= 16*7;
            IF PointDeFuite.Y > GetMaxY THEN PointDeFuite.Y:= GetMaxY;
            IF PointDeFuite.Z < 500 THEN PointDeFuite.Z:= 500;

            END;

            ClearKbdBuf;
            IF Port[$60] = 1 THEN Break;
            IF Port[$60] = 19 THEN GOTO Reset;
            IF Port[$60] = 32 THEN BEGIN
               GColor(6584,00000);
               CASE DemoMode OF
                    TRUE  : GWrite('On',12,8);
                    FALSE : GWrite('Off',15,8);
               END;
               DemoMode:= NOT DemoMode;
               GColor(29949,00000);
               CASE DemoMode OF
                    TRUE  : GWrite('On',12,8);
                    FALSE : GWrite('Off',15,8);
               END;
            END;

            Port[$60]:= 0;
      END;

      Port[$60]:= 0;
      UnLoadFont;
      SetTextMode(3); SetCursorSize(15,16); SetCursorPos(1,1); Halt(0);
 END.